VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketWrench Chat Client"
   ClientHeight    =   4575
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   7740
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4575
   ScaleWidth      =   7740
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtl.SocketWrench Socket1 
      Left            =   6720
      Top             =   720
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   375
      Left            =   6360
      TabIndex        =   6
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox Text3 
      Height          =   285
      Left            =   4560
      TabIndex        =   5
      Top             =   180
      Width           =   1455
   End
   Begin VB.TextBox Text5 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Top             =   4200
      Width           =   7455
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   3000
      TabIndex        =   3
      Text            =   "7000"
      Top             =   180
      Width           =   735
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Text            =   "127.0.0.1"
      Top             =   180
      Width           =   1575
   End
   Begin VB.TextBox Text4 
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3495
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   640
      Width           =   7455
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Name:"
      Height          =   195
      Left            =   3960
      TabIndex        =   4
      Top             =   200
      Width           =   465
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   2520
      TabIndex        =   2
      Top             =   200
      Width           =   330
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Server:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   200
      Width           =   510
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private strHostName As String
Private strUserName As String
Private nHostPort As Long

Private Sub Command1_Click()
    Dim nError As Long
    
    If Socket1.IsConnected Then
        Socket1.Disconnect
        Command1.Caption = "Connect"
        Text5.Text = ""
        Text5.Enabled = False
        Exit Sub
    End If
    
    strHostName = Trim(Text1.Text)
    nHostPort = CLng(Text2.Text)
    strUserName = Trim(Text3.Text)
    
    If Len(strHostName) = 0 Then
        MsgBox "Please enter the hostname or address of the chat server", vbExclamation
        Text1.SetFocus
        Exit Sub
    End If
        
    If nHostPort < 1 Or nHostPort > 65535 Then
        MsgBox "Please enter a valid port number for the chat server", vbExclamation
        Text2.SetFocus
        Exit Sub
    End If
    
    If Len(strUserName) < 3 Then
        MsgBox "Please enter a valid username for the chat server", vbExclamation
        Text3.SetFocus
        Exit Sub
    End If
    
    Command1.Enabled = False
    
    Socket1.Blocking = False
   
    nError = Socket1.Connect(strHostName, nHostPort)
    If nError > 0 Then
        MsgBox Socket1.LastErrorString, vbExclamation
        Command1.Enabled = True
        Exit Sub
    End If
    
    Socket1.Interval = 5000
End Sub

Private Sub Socket1_OnConnect()
    Dim nResult As Long
    
    Socket1.Interval = 0
    nResult = Socket1.Write(strUserName + vbCrLf)
    If nResult = -1 Then
        MsgBox "Unable to authenticate client session with server", vbExclamation
        Socket1.Disconnect
        Command1.Caption = "Connect"
        Exit Sub
    End If

    Command1.Enabled = True
    Command1.Default = False
    Command1.Caption = "Disconnect"
    Text4.Text = ""
    Text5.Text = ""
    Text5.Enabled = True
    Text5.SetFocus
End Sub

Private Sub Socket1_OnDisconnect()
    Socket1.Disconnect
    Command1.Caption = "Connect"
    Text5.Text = ""
    Text5.Enabled = False
    MsgBox "You have been disconnected from the chat server", vbInformation
End Sub

Private Sub Socket1_OnRead()
    Dim strBuffer As String
    Dim nResult As Long
    
    nResult = Socket1.Read(strBuffer)
    If nResult > 0 Then
        Text4.SelStart = Len(Text4.Text) + 1
        Text4.SelLength = 0
        Text4.SelText = strBuffer
    ElseIf nResult = -1 Then
        Debug.Print "Error: " + Socket1.LastErrorString
    End If
End Sub

Private Sub Socket1_OnTimer()
    Socket1.Interval = 0
    Socket1.Disconnect
    
    MsgBox "Unable to establish a connection with the chat server", vbExclamation
    Command1.Enabled = True
    Command1.Caption = "Connect"
    Command1.Default = True
End Sub

Private Sub Text4_KeyPress(KeyAscii As Integer)
    If KeyAscii = 1 Then ' Ctrl+A
        Text4.SelStart = 0
        Text4.SelLength = Len(Text4.Text)
        KeyAscii = 0
    ElseIf KeyAscii <> 3 Then ' Ctrl+C
        KeyAscii = 0
    End If
End Sub

Private Sub Text5_KeyPress(KeyAscii As Integer)
    Dim nResult As Long
    
    If KeyAscii = 13 Then
        nResult = Socket1.Write(Text5.Text + vbCrLf)
        
        If nResult = -1 Then
            Debug.Print "Error: " + Socket1.LastErrorString
            Beep
        End If
        
        Text5.Text = ""
        KeyAscii = 0
    End If
End Sub
