VERSION 5.00
Object = "{8A718D2D-8AF7-4B72-A074-093208112A54}#1.0#0"; "cswsvx10.ocx"
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketWrench Chat Server"
   ClientHeight    =   3720
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   7155
   LinkTopic       =   "Form1"
   ScaleHeight     =   3720
   ScaleWidth      =   7155
   StartUpPosition =   3  'Windows Default
   Begin InternetServerCtl.InternetServer Server1 
      Left            =   5760
      Top             =   1680
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ListBox List1 
      Height          =   2595
      Left            =   120
      TabIndex        =   7
      Top             =   840
      Width           =   5415
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   840
      TabIndex        =   1
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton Command3 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   375
      Left            =   5760
      TabIndex        =   10
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   5760
      TabIndex        =   9
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   5760
      TabIndex        =   8
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox Text2 
      Height          =   315
      Left            =   4680
      TabIndex        =   5
      Text            =   "100"
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   3240
      TabIndex        =   3
      Text            =   "7000"
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Status1 
      Height          =   285
      Left            =   120
      TabIndex        =   11
      Top             =   3480
      Width           =   6915
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Connections:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   520
      Width           =   930
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Clients:"
      Height          =   195
      Left            =   4080
      TabIndex        =   4
      Top             =   180
      Width           =   510
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   2760
      TabIndex        =   2
      Top             =   180
      Width           =   330
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Address:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   615
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' A table of active client connections with state information
' stored by the server using a Dictionary object
Private ClientTable As New Collection

Private Sub Form_Load()
    Dim nIndex As Long
    
    ' Initialize the Combo1 combobox control with a list of
    ' the available IP addresses that we can use to listen
    ' for connections
    
    Combo1.AddItem "<Any Address>" ' Listen on any interface
    Combo1.AddItem "127.0.0.1"     ' Listen on the loopback interface
    
    For nIndex = 0 To Server1.AdapterCount - 1
        Combo1.AddItem Server1.AdapterAddress(nIndex)
    Next
    
    ' Default to listening on any network interface
    Combo1.ListIndex = 0

    ' Update the status label
    Status1.Caption = "The server is not listening for client connections"
End Sub

Private Sub Command1_Click()
    Dim strLocalAddress As String
    Dim nLocalPort As Long
    Dim nMaxClients As Long
    Dim nError As Long
        
    If Not Server1.IsActive Then
        ' The server is inactive, so we begin listening for
        ' connections using the address and port number that
        ' the user has specified
        strLocalAddress = Trim(Combo1.Text)
        nLocalPort = CLng(Text1.Text)
        nMaxClients = CLng(Text2.Text)
        
        ' If the user has specified that they want the server
        ' to listen on any network interface, then we use the
        ' special address 0.0.0.0
        If strLocalAddress = "<Any Address>" Then
            strLocalAddress = "0.0.0.0"
        End If
        
        ' Make sure that a valid port number has been entered
        If nLocalPort < 1 Or nLocalPort > 65535 Then
            MsgBox "Please specify a valid port number for the server", vbExclamation
            Text1.SetFocus
            Exit Sub
        End If
            
        UpdateForm False
        
        ' Clear the client table
        Do While ClientTable.Count > 0
            ClientTable.Remove 1
        Loop
            
        ' Start the server
        nError = Server1.Start(strLocalAddress, nLocalPort, MaxClients:=nMaxClients)
        If nError > 0 Then
            ShowError
            Command1.Enabled = True
            Exit Sub
        End If
            
        UpdateForm True
    Else
        ' The server is active, so we'll disconnect all active client
        ' connections and close the listening socket
        
        nError = Server1.Stop()
        If nError > 0 Then
            ShowError
            Exit Sub
        End If
    
        List1.Clear
        UpdateForm True
    End If
End Sub

Private Sub Command2_Click()
    Dim hClient As Long
    Dim nError As Long
    
    If List1.ListCount = 0 Then
        MsgBox "There are no clients connected to the server", vbExclamation
        Exit Sub
    End If
    
    If List1.ListIndex = -1 Then
        MsgBox "No client has been selected", vbExclamation
        List1.SetFocus
        Exit Sub
    End If
    
    hClient = List1.ItemData(List1.ListIndex)
        
    nError = Server1.Disconnect(hClient)
    If nError > 0 Then
        ShowError
    End If
End Sub

Private Sub Command3_Click()
    Dim idResult As VbMsgBoxResult
    
    ' Check to make sure that the user really wants to disconnect the
    ' active client connections
    If Server1.ClientCount > 0 Then
        idResult = MsgBox("All client connections will be terminated", vbInformation + vbOKCancel)
        If idResult = vbCancel Then Exit Sub
    End If
    
    Unload Me
End Sub

Private Sub Server1_OnConnect(ByVal Handle As Variant)
    ' A client has connected to the server
    Dim Client As New ChatClient
    
    Client.Initialize Server1.ClientId, Server1.ClientAddress
    ClientTable.Add Client, CStr(Handle)

    Debug.Print "Client " + CStr(Server1.ClientId) + " connected to server from " + Server1.ClientAddress
    Status1.Caption = CStr(Server1.ClientCount) + " clients are connected to the server"
End Sub

Private Sub Server1_OnDisconnect(ByVal Handle As Variant)
    Dim Client As ChatClient
    Dim nIndex As Long
    
    ' Get information about our client from the ClientTable collection
    ' Note that because we've been disconnected, the client session is
    ' no longer valid and Server1.ClientId won't return a meaningful
    ' value to us, so we use the value stored in the ChatClient class
    Set Client = ClientTable.Item(CStr(Handle))
    Debug.Print "Client " + CStr(Client.ClientId) + " disconnected from server"
    
    ' If the client has been authenticated, then let the other clients
    ' knoow that they are leaving the chat
    If Client.Authenticated Then
        Server1.Broadcast "Server [" + Format(Now, "hh:mm") + "] " + Client.UserName + " has left the chat" + vbCrLf
        ' Remove the client from the listbox
        For nIndex = 0 To List1.ListCount - 1
            If List1.ItemData(nIndex) = Handle Then
                List1.RemoveItem nIndex
                Exit For
            End If
        Next
    End If
    
    ' Remove the client from our table
    ClientTable.Remove CStr(Handle)
    
    ' Update the user interface
    Status1.Caption = CStr(Server1.ClientCount) + " clients are connected to the server"
End Sub

Private Sub Server1_OnRead(ByVal Handle As Variant)
    Dim Client As ChatClient
    Dim strBuffer As String
    
    ' Get information about our client from the ClientTable collection
    Set Client = ClientTable.Item(CStr(Handle))

    ' If the client session has not been authenticated, then the first
    ' line of data sent by the client should be its authentication info
    If Not Client.Authenticated Then
        ' Read the authentication information from the client
        If Server1.ReadLine(Handle, strBuffer) Then
            If Client.Authenticate(strBuffer) Then
                ' Broadcast a message to all other clients and add the client
                ' username to our listbox control
                Server1.Broadcast "Server [" + Format(Now, "hh:mm") + "] " + Client.UserName + " has joined the chat" + vbCrLf
                Server1.WriteLine Handle, "Server [" + Format(Now, "hh:mm") + "] You have joined the chat with " + CStr(Server1.ClientCount - 1) + " other users"
                List1.AddItem Client.UserName + " connected on " + Format(Client.Connected, "MM/DD/YYYY hh:mm") + " from " + Client.Address
                List1.ItemData(List1.NewIndex) = Handle
                List1.Selected(List1.NewIndex) = True
            Else
                ' The client session could not be authenticated, send a
                ' message to the client and terminate the session
                Server1.WriteLine Handle, "Server [" + Format(Now, "hh:mm") + "] Unable to authenticate client session"
                Server1.Disconnect Handle
            End If
        Else
            ' If we were unable to read the authentication string then
            ' terminate the client session
            Debug.Print "Client " + CStr(Server1.ClientId) + " did not authenticate"
            Server1.Disconnect Handle
        End If
        Exit Sub
    End If
    
    If Server1.ReadLine(Handle, strBuffer) Then
        ' Broadcast the message to all other clients
        Server1.Broadcast Client.UserName + " [" + Format(Now, "hh:mm") + "] " + strBuffer + vbCrLf
        ' Echo the message back to the client
        Server1.WriteLine Handle, Client.UserName + " [" + Format(Now, "hh:mm") + "] " + strBuffer
    End If
End Sub

' Update the form buttons based on the state of the server
Private Sub UpdateForm(ByVal bEnable As Boolean)
    ' Enable or disable the command buttons
    Command1.Enabled = bEnable
    Command2.Enabled = bEnable
    
    If bEnable Then List1.SetFocus
    
    ' Update the caption for the Start/Stop button based on
    ' the current status of the server
    If Not Server1.IsActive Then
        Command1.Caption = "Start"
        Status1.Caption = "The server is not listening for client connections"
    Else
        Command1.Caption = "Stop"
        Status1.Caption = CStr(Server1.ClientCount) + " clients are connected to the server"
    End If
End Sub

' Update the status label with the error information and
' display a message box to the user
Private Sub ShowError()
    MainForm.Status1.Caption = "Error " + CStr(Server1.LastError) + ": " + Server1.LastErrorString
    MsgBox Server1.LastErrorString, vbExclamation
End Sub
