VERSION 5.00
Object = "{134425FD-0EED-45E9-84C8-D1460B21C054}#1.0#0"; "csftsx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools FTP Server Example"
   ClientHeight    =   5280
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8040
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5280
   ScaleWidth      =   8040
   StartUpPosition =   2  'CenterScreen
   Begin FtpServerCtl.FtpServer FtpServer1 
      Left            =   6720
      Top             =   2400
      _cx             =   741
      _cy             =   741
   End
   Begin VB.Frame frameLogging 
      Caption         =   "Logging"
      Height          =   855
      Left            =   120
      TabIndex        =   36
      Top             =   3960
      Width           =   6135
      Begin VB.TextBox editLogFile 
         Height          =   285
         Left            =   2240
         TabIndex        =   39
         Text            =   "%AppData%\SocketTools\FtpServer.log"
         ToolTipText     =   "The name of the file that will contain a log of client activity"
         Top             =   300
         Width           =   3680
      End
      Begin VB.ComboBox comboFormats 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   37
         ToolTipText     =   "The format that should be used when logging client activity"
         Top             =   300
         Width           =   1600
      End
      Begin VB.Label lblLogFile 
         Caption         =   "File:"
         Height          =   255
         Left            =   1840
         TabIndex        =   38
         Top             =   340
         Width           =   300
      End
   End
   Begin VB.Frame frameOptions 
      Caption         =   "Options"
      Height          =   2200
      Left            =   120
      TabIndex        =   16
      Top             =   1680
      Width           =   6135
      Begin VB.CheckBox chkLockFiles 
         Caption         =   "Lock Files"
         Height          =   255
         Left            =   2400
         TabIndex        =   33
         ToolTipText     =   "Lock files during transfers"
         Top             =   1740
         Width           =   1650
      End
      Begin VB.CheckBox chkUnixMode 
         Caption         =   "Unix Mode"
         Height          =   255
         Left            =   2400
         TabIndex        =   31
         ToolTipText     =   "File information and directory listings should use the standard UNIX format"
         Top             =   1080
         Value           =   1  'Checked
         Width           =   1650
      End
      Begin VB.CheckBox chkLocalTime 
         Caption         =   "Local File Times"
         Height          =   255
         Left            =   2400
         TabIndex        =   32
         ToolTipText     =   "File dates and times should use the local system time"
         Top             =   1400
         Width           =   1650
      End
      Begin VB.CheckBox chkLocalUser 
         Caption         =   "Local Users"
         Height          =   255
         Left            =   140
         TabIndex        =   28
         ToolTipText     =   "Allow clients to authenticate as users on the local Windows system"
         Top             =   1080
         Value           =   1  'Checked
         Width           =   1650
      End
      Begin VB.CheckBox chkMultiUser 
         Caption         =   "User Directories"
         Height          =   255
         Left            =   140
         TabIndex        =   30
         ToolTipText     =   "Users should have their own home directories"
         Top             =   1740
         Width           =   1650
      End
      Begin VB.CheckBox chkHidden 
         Caption         =   "Hidden Files"
         Height          =   255
         Left            =   4335
         TabIndex        =   35
         ToolTipText     =   "The server should allow access to hidden files"
         Top             =   1400
         Width           =   1650
      End
      Begin VB.CheckBox chkReadOnly 
         Caption         =   "Read Only"
         Height          =   255
         Left            =   4335
         TabIndex        =   34
         ToolTipText     =   "The server will only permit files to be downloaded"
         Top             =   1080
         Width           =   1650
      End
      Begin VB.CheckBox chkRestricted 
         Caption         =   "Restricted Access"
         Height          =   255
         Left            =   140
         TabIndex        =   29
         ToolTipText     =   "Restrict access to the server, limiting the commands that can be used by clients"
         Top             =   1400
         Width           =   1650
      End
      Begin VB.TextBox editMaxLogins 
         Height          =   285
         Left            =   1000
         TabIndex        =   24
         Text            =   "3"
         Top             =   630
         Width           =   700
      End
      Begin VB.TextBox editMaxPort 
         Height          =   285
         Left            =   5300
         TabIndex        =   27
         Text            =   "65535"
         ToolTipText     =   "The maximum port number to use for active data transfers"
         Top             =   630
         Width           =   700
      End
      Begin VB.TextBox editMinPort 
         Height          =   285
         Left            =   4560
         TabIndex        =   26
         Text            =   "32768"
         ToolTipText     =   "The minimum port number to use for active data transfers"
         Top             =   630
         Width           =   700
      End
      Begin VB.TextBox editIdleTime 
         Height          =   285
         Left            =   4560
         TabIndex        =   22
         Text            =   "300"
         ToolTipText     =   "The number of seconds a client can remain idle before being disconnected"
         Top             =   280
         Width           =   700
      End
      Begin VB.TextBox editMaxGuests 
         Height          =   285
         Left            =   2760
         TabIndex        =   20
         Text            =   "20"
         ToolTipText     =   "The maximum number of anonymous guest connections allowed"
         Top             =   280
         Width           =   700
      End
      Begin VB.TextBox editMaxClients 
         Height          =   285
         Left            =   1000
         TabIndex        =   18
         Text            =   "100"
         ToolTipText     =   "The maximum number of client connections allowed"
         Top             =   280
         Width           =   700
      End
      Begin VB.Label lblLogins 
         Caption         =   "Logins:"
         Height          =   255
         Left            =   140
         TabIndex        =   23
         Top             =   640
         Width           =   680
      End
      Begin VB.Label lblPorts 
         Caption         =   "Ports:"
         Height          =   255
         Left            =   3720
         TabIndex        =   25
         Top             =   640
         Width           =   690
      End
      Begin VB.Label lblIdle 
         Caption         =   "Timeout:"
         Height          =   255
         Left            =   3720
         TabIndex        =   21
         Top             =   300
         Width           =   690
      End
      Begin VB.Label lblMaxGuests 
         Caption         =   "Guests:"
         Height          =   255
         Left            =   2025
         TabIndex        =   19
         Top             =   300
         Width           =   675
      End
      Begin VB.Label lblMaxClients 
         Caption         =   "Clients:"
         Height          =   255
         Left            =   140
         TabIndex        =   17
         Top             =   300
         Width           =   680
      End
   End
   Begin VB.Frame frameServer 
      Caption         =   "Server"
      Height          =   1455
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   6135
      Begin VB.TextBox editDirectory 
         Height          =   315
         Left            =   1000
         TabIndex        =   15
         Text            =   "%AppData%\SocketTools\FtpServer"
         ToolTipText     =   "The root directory for the server where files will be stored"
         Top             =   960
         Width           =   5000
      End
      Begin VB.TextBox editIdentity 
         Height          =   315
         Left            =   3800
         TabIndex        =   8
         Text            =   "SocketTools 10.0"
         ToolTipText     =   "A value that identifies the server application and version"
         Top             =   240
         Width           =   2200
      End
      Begin VB.CheckBox chkSecure 
         Caption         =   "Secure"
         Height          =   255
         Left            =   4560
         TabIndex        =   13
         ToolTipText     =   "Support secure client connections using the SSL and TLS protocols"
         Top             =   620
         Width           =   855
      End
      Begin VB.TextBox editLocalPort 
         Height          =   285
         Left            =   3800
         TabIndex        =   12
         Text            =   "21"
         ToolTipText     =   "The port number the server will use to listen for connections"
         Top             =   620
         Width           =   600
      End
      Begin VB.TextBox editLocalAddress 
         Height          =   315
         Left            =   1000
         TabIndex        =   10
         Text            =   "127.0.0.1"
         ToolTipText     =   "The local IP address that the server will use to listen for connections"
         Top             =   620
         Width           =   2000
      End
      Begin VB.TextBox editHostName 
         Height          =   315
         Left            =   1000
         TabIndex        =   6
         Text            =   "localhost"
         ToolTipText     =   "The fully qualified domain name for the server"
         Top             =   240
         Width           =   2000
      End
      Begin VB.Label lblDirectory 
         Caption         =   "Directory:"
         Height          =   255
         Left            =   140
         TabIndex        =   14
         Top             =   1000
         Width           =   680
      End
      Begin VB.Label lblIdentity 
         Caption         =   "Identity:"
         Height          =   255
         Left            =   3100
         TabIndex        =   7
         Top             =   280
         Width           =   640
      End
      Begin VB.Label lblLocalPort 
         Caption         =   "Port:"
         Height          =   255
         Left            =   3100
         TabIndex        =   11
         Top             =   640
         Width           =   350
      End
      Begin VB.Label lblLocalAddress 
         Caption         =   "Address:"
         Height          =   255
         Left            =   140
         TabIndex        =   9
         Top             =   640
         Width           =   680
      End
      Begin VB.Label lblHostName 
         Caption         =   "Name:"
         Height          =   255
         Left            =   140
         TabIndex        =   5
         Top             =   280
         Width           =   680
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   6600
      TabIndex        =   3
      Top             =   1800
      Width           =   1215
   End
   Begin VB.CommandButton cmdRestart 
      Caption         =   "Restart"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   2
      Top             =   1266
      Width           =   1215
   End
   Begin VB.CommandButton cmdSuspend 
      Caption         =   "Suspend"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   1
      Top             =   733
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   0
      Top             =   200
      Width           =   1215
   End
   Begin VB.Label lblClient 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0 Clients"
      Height          =   315
      Left            =   6360
      TabIndex        =   41
      Top             =   4950
      Width           =   1660
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   0
      TabIndex        =   40
      Top             =   4950
      Width           =   6285
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    comboFormats.AddItem "None", 0
    comboFormats.AddItem "Common", 1
    comboFormats.AddItem "Extended", 2
    comboFormats.ListIndex = 0
End Sub

Private Sub UpdateForm(ByVal bEnable As Boolean)
    If FtpServer1.IsActive Then
        cmdStart.Enabled = bEnable
        cmdSuspend.Enabled = bEnable
        cmdRestart.Enabled = bEnable
    Else
        cmdStart.Enabled = bEnable
        cmdSuspend.Enabled = False
        cmdRestart.Enabled = False
    End If
End Sub

Private Sub UpdateStatus(strMessage)
    lblStatus.Caption = strMessage
    lblClient.Caption = FtpServer1.ClientCount & " Clients"
End Sub

Private Sub cmdStart_Click()
    Dim nError As Long
    
    If Not FtpServer1.IsActive Then
        
        UpdateForm False
        
        ' Basic server configuration
        FtpServer1.ServerName = Trim(editHostName.Text)
        FtpServer1.ServerAddress = Trim(editLocalAddress.Text)
        FtpServer1.ServerPort = CLng(Trim(editLocalPort.Text))
        FtpServer1.Identity = Trim(editIdentity.Text)
        FtpServer1.Directory = Trim(editDirectory.Text)
        
        ' Server limits
        FtpServer1.MaxClients = CLng(editMaxClients.Text)
        FtpServer1.MaxGuests = CLng(editMaxGuests.Text)
        FtpServer1.IdleTime = CLng(editIdleTime.Text)
        FtpServer1.AuthFail = CLng(editMaxLogins.Text)
        FtpServer1.MinPort = CLng(editMinPort.Text)
        FtpServer1.MaxPort = CLng(editMaxPort.Text)
        
        ' Server options
        FtpServer1.Secure = CBool(chkSecure.Value)
        FtpServer1.LocalUser = CBool(chkLocalUser.Value)
        FtpServer1.MultiUser = CBool(chkMultiUser.Value)
        FtpServer1.UnixMode = CBool(chkUnixMode.Value)
        FtpServer1.LocalTime = CBool(chkLocalTime.Value)
        FtpServer1.LockFiles = CBool(chkLockFiles.Value)
        FtpServer1.Restricted = CBool(chkRestricted.Value)
        FtpServer1.ReadOnly = CBool(chkReadOnly.Value)
        FtpServer1.HiddenFiles = CBool(chkHidden.Value)
        
        ' Server logging
        FtpServer1.LogFormat = comboFormats.ListIndex
        FtpServer1.LogFile = Trim(editLogFile.Text)
        
        ' Start the server
        nError = FtpServer1.Start()
        If nError > 0 Then
            MsgBox FtpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        cmdStart.Caption = "Stop"
        UpdateStatus "Server accepting connections on " & FtpServer1.ServerAddress & ":" & FtpServer1.ServerPort
        UpdateForm True
    Else
        UpdateForm False
        
        nError = FtpServer1.Stop()
        
        If nError > 0 Then
            MsgBox FtpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        cmdStart.Caption = "Start"
    End If
End Sub

Private Sub cmdSuspend_Click()
    Dim nError As Long
    
    If cmdSuspend.Caption = "Suspend" Then
        UpdateForm False
            
        nError = FtpServer1.Suspend()
        
        If nError > 0 Then
            MsgBox FtpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
            
        cmdSuspend.Caption = "Resume"
        UpdateStatus "Server suspended accepting new client connections"
        UpdateForm True
    Else
        UpdateForm False
            
        nError = FtpServer1.Resume()
            
        If nError > 0 Then
            MsgBox FtpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
            
        cmdSuspend.Caption = "Suspend"
        UpdateStatus "Server resumed accepting new client connections"
        UpdateForm True
    End If
    
End Sub

Private Sub cmdRestart_Click()
    Dim nError As Long
    
    UpdateForm False
    
    nError = FtpServer1.Restart()
    If nError > 0 Then
        MsgBox FtpServer1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    UpdateStatus "The server has been restarted"
    UpdateForm True
End Sub

Private Sub cmdClose_Click()
    Dim nError As Long
    
    If FtpServer1.IsActive Then
        UpdateForm False
        
        nError = FtpServer1.Stop()
        
        If nError > 0 Then
            MsgBox FtpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        UpdateForm True
    End If

    Unload Me
End Sub

Private Sub FtpServer1_OnAuthenticate(ByVal ClientId As Variant, ByVal HostName As Variant, ByVal UserName As Variant, ByVal Password As Variant)
    Debug.Print "Client " & ClientId & " authenticating as " & UserName
End Sub

Private Sub FtpServer1_OnCommand(ByVal ClientId As Variant, ByVal Command As Variant, ByVal Parameters As Variant)
    Debug.Print "Client " & ClientId & " sent command " & Command & " [" & Parameters & "]"
    Debug.Print "Virtual Path: " & FtpServer1.VirtualPath
    Debug.Print "Local Path:   " & FtpServer1.LocalPath

    If Command = "SITE" Then
        If UCase(Parameters) = "TIME" Then
            FtpServer1.SendResponse ClientId, 200, "The local time is " & Date & " " & Time
        End If
    End If
    
End Sub

Private Sub FtpServer1_OnConnect(ByVal ClientId As Variant, ByVal ClientAddress As Variant)
    Debug.Print "Client " & ClientId & " connected from " & ClientAddress
    UpdateStatus "Client " & ClientId & " connected from " & ClientAddress
End Sub

Private Sub FtpServer1_OnDisconnect(ByVal ClientId As Variant)
    Debug.Print "Client " & ClientId & " disconnected"
    UpdateStatus "Client " & ClientId & " disconnected from the server"
End Sub

Private Sub FtpServer1_OnDownload(ByVal ClientId As Variant, ByVal FileName As Variant, ByVal FileSize As Variant)
    Debug.Print "Client " & ClientId & " downloaded " & FileName
End Sub

Private Sub FtpServer1_OnError(ByVal ClientId As Variant, ByVal ErrorCode As Variant, ByVal Description As Variant)
    Debug.Print "Client " & ClientId & " error " & ErrorCode & ": " & Description
End Sub

Private Sub FtpServer1_OnExecute(ByVal ClientId As Variant, ByVal Program As Variant, ByVal Output As Variant, ByVal ExitCode As Variant)
    Debug.Print "Client " & ClientId & " executed " & Program & " (" & ExitCode & ")"
End Sub

Private Sub FtpServer1_OnIdle()
    Debug.Print "All clients have disconnected, the server is idle"
End Sub

Private Sub FtpServer1_OnLogin(ByVal ClientId As Variant, ByVal UserName As Variant, ByVal Directory As Variant)
    Debug.Print "Client " & ClientId & " logged in as " & UserName & " (" & Directory & ")"
End Sub

Private Sub FtpServer1_OnLogout(ByVal ClientId As Variant, ByVal UserName As Variant)
    Debug.Print "Client " & ClientId & " logged out as " & UserName
End Sub

Private Sub FtpServer1_OnResult(ByVal ClientId As Variant, ByVal Command As Variant, ByVal ResultCode As Variant)
    Debug.Print "Client " & ClientId & " command " & Command & " completed (" & ResultCode & ")"
End Sub

Private Sub FtpServer1_OnStart()
    Debug.Print "Server has started accepting connections"
    UpdateStatus "Server accepting connections on " & FtpServer1.ServerAddress & ":" & FtpServer1.ServerPort
    UpdateForm True
End Sub

Private Sub FtpServer1_OnStop()
    Debug.Print "Server has stopped, all clients terminated"
    UpdateStatus "Server stopped accepting connections"
    UpdateForm True
End Sub

Private Sub FtpServer1_OnTimeout(ByVal ClientId As Variant, ByVal Elapsed As Variant)
    Debug.Print "Client " & ClientId & " timed out after " & Elapsed & " seconds"
End Sub

Private Sub FtpServer1_OnUpload(ByVal ClientId As Variant, ByVal FileName As Variant, ByVal FileSize As Variant)
    Debug.Print "Client " & ClientId & " uploaded " & FileName
End Sub
