VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{18C48A03-9F18-43ED-B617-D814611A8A44}#1.0#0"; "csmapx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools ListMail Example"
   ClientHeight    =   7125
   ClientLeft      =   4125
   ClientTop       =   3075
   ClientWidth     =   9165
   Icon            =   "ListMail.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7125
   ScaleWidth      =   9165
   Begin ImapClientCtl.ImapClient ImapClient1 
      Left            =   7260
      Top             =   120
      _cx             =   741
      _cy             =   741
      Enabled         =   -1  'True
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "Refresh"
      Height          =   375
      Left            =   7800
      TabIndex        =   13
      Top             =   540
      Width           =   1215
   End
   Begin VB.ComboBox comboMailbox 
      Height          =   315
      Left            =   1140
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   11
      Top             =   1020
      Width           =   2475
   End
   Begin VB.TextBox editTimeout 
      Height          =   315
      Left            =   6120
      TabIndex        =   5
      Text            =   "30"
      Top             =   180
      Width           =   555
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   315
      Left            =   5640
      TabIndex        =   18
      Top             =   6780
      Width           =   3435
      _ExtentX        =   6059
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdView 
      Caption         =   "View"
      Enabled         =   0   'False
      Height          =   375
      Left            =   7800
      TabIndex        =   14
      Top             =   1020
      Width           =   1215
   End
   Begin VB.TextBox editPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   4680
      PasswordChar    =   "*"
      TabIndex        =   9
      Top             =   600
      Width           =   2475
   End
   Begin VB.TextBox editUserName 
      Height          =   315
      Left            =   1140
      TabIndex        =   7
      Top             =   600
      Width           =   2475
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   1140
      TabIndex        =   1
      Top             =   180
      Width           =   2475
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   375
      Left            =   7800
      TabIndex        =   12
      Top             =   60
      Width           =   1215
   End
   Begin VB.TextBox editHostPort 
      Height          =   315
      Left            =   4680
      TabIndex        =   3
      Text            =   "143"
      Top             =   180
      Width           =   555
   End
   Begin VB.TextBox textMessage 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5175
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   16
      Top             =   1500
      Visible         =   0   'False
      Width           =   9015
   End
   Begin MSComctlLib.ListView listMessages 
      Height          =   5235
      Left            =   60
      TabIndex        =   15
      Top             =   1500
      Width           =   9015
      _ExtentX        =   15901
      _ExtentY        =   9234
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label lblMailbox 
      Caption         =   "Mailbox:"
      Height          =   195
      Left            =   180
      TabIndex        =   10
      Top             =   1080
      Width           =   915
   End
   Begin VB.Label lblTimeout 
      Caption         =   "Timeout:"
      Height          =   195
      Left            =   5400
      TabIndex        =   4
      Top             =   240
      Width           =   675
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   60
      TabIndex        =   17
      Top             =   6780
      Width           =   5595
   End
   Begin VB.Label lblPassword 
      Caption         =   "Password:"
      Height          =   195
      Left            =   3780
      TabIndex        =   8
      Top             =   660
      Width           =   795
   End
   Begin VB.Label lblUserName 
      Caption         =   "User Name:"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   660
      Width           =   915
   End
   Begin VB.Label lblPort 
      Caption         =   "Server Port:"
      Height          =   195
      Left            =   3780
      TabIndex        =   2
      Top             =   240
      Width           =   855
   End
   Begin VB.Label lblServer 
      Caption         =   "Mail Server:"
      Height          =   195
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   915
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

' ListView column header constants
Private Const lvcSubject = 1
Private Const lvcDate = 2

Private Sub Form_Load()
    Dim colHeader As ColumnHeader
    
    cmdConnect.Enabled = True
    cmdRefresh.Enabled = False
    cmdView.Enabled = False
    
    comboMailbox.Enabled = False
    textMessage.Visible = False
    listMessages.Visible = True
    listMessages.View = lvwReport
    Set colHeader = listMessages.ColumnHeaders.Add(, , "From", 1600)
    Set colHeader = listMessages.ColumnHeaders.Add(, , "Subject", 4550)
    Set colHeader = listMessages.ColumnHeaders.Add(, , "Date", 2500)

    ProgressBar1.Min = 0
    ProgressBar1.Max = 100
    ProgressBar1.Value = 0
End Sub

Private Sub cmdConnect_Click()
    Dim strHostName As String
    Dim strHostPort As String
    Dim strTimeout As String
    Dim strUserName As String
    Dim strPassword As String
    Dim nHostPort As Long
    Dim nTimeout As Long
    Dim nIndex As Long
    Dim nInbox As Long
    Dim nError As Long
    
    If ImapClient1.IsConnected Then
        ' Disconnect from mail server
        ImapClient1.Disconnect
        
        ' Update user interface
        comboMailbox.Clear
        comboMailbox.Enabled = False
        listMessages.ListItems.Clear
        listMessages.Visible = True
        textMessage.Text = ""
        textMessage.Visible = False
        
        cmdRefresh.Enabled = False
        cmdView.Enabled = False
        cmdView.Caption = "View"
        cmdConnect.Caption = "Connect"
        Exit Sub
    End If
    
    strHostName = Trim(editHostName.Text)
    If Len(strHostName) = 0 Then
        MsgBox "Please specify the server host name or address", vbInformation
        editHostName.Text = ""
        editHostName.SetFocus
        Exit Sub
    End If
    
    strHostPort = Trim(editHostPort.Text)
    If Len(strHostPort) > 0 Then
        nHostPort = Val(strHostPort)
        If nHostPort < 0 Or nHostPort > 65535 Then
            MsgBox "Please specify a valid port number", vbExclamation
            editHostPort.Text = ""
            editHostPort.SetFocus
            Exit Sub
        ElseIf nHostPort = 0 Then
            nHostPort = imapPortDefault
            editHostPort.Text = CStr(nHostPort)
        End If
    Else
        MsgBox "Please specify a server port number", vbInformation
        editHostPort.Text = ""
        editHostPort.SetFocus
        Exit Sub
    End If
    
    strTimeout = Trim(editTimeout.Text)
    If Len(strTimeout) > 0 Then
        nTimeout = Val(strTimeout)
        editTimeout.Text = CStr(nTimeout)
    Else
        MsgBox "Please specify a timeout value in seconds", vbInformation
        editTimeout.Text = ""
        editTimeout.SetFocus
        Exit Sub
    End If
        
    strUserName = Trim(editUserName.Text)
    If Len(strUserName) = 0 Then
        MsgBox "Please specify a user name", vbInformation
        editUserName.Text = ""
        editUserName.SetFocus
        Exit Sub
    End If
    
    strPassword = Trim(editPassword.Text)
    If Len(strPassword) = 0 Then
        MsgBox "Please specify a password", vbInformation
        editPassword.Text = ""
        editPassword.SetFocus
        Exit Sub
    End If
    
    cmdConnect.Enabled = False
    
    nError = ImapClient1.Connect(strHostName, _
                                 nHostPort, _
                                 strUserName, _
                                 strPassword, _
                                 nTimeout)
    
    If nError <> 0 Then
        lblStatus.Caption = ImapClient1.LastErrorString
        MsgBox ImapClient1.LastErrorString, vbExclamation
        cmdConnect.Enabled = True
        Exit Sub
    End If
        
    comboMailbox.Clear
    
    If ImapClient1.Mailboxes = 0 Then
        MsgBox "There are no mailboxes available", vbExclamation
        ImapClient1.Disconnect
        cmdConnect.Enabled = True
        Exit Sub
    End If
    
    For nIndex = 0 To ImapClient1.Mailboxes - 1
        comboMailbox.AddItem ImapClient1.Mailbox(nIndex)
    Next
        
    nInbox = -1
    For nIndex = 0 To comboMailbox.ListCount - 1
        If StrComp(comboMailbox.List(nIndex), "Inbox", vbTextCompare) = 0 Then
            nInbox = nIndex
            Exit For
        End If
    Next
    
    comboMailbox.Enabled = True
    comboMailbox.ListIndex = nInbox
    cmdConnect.Caption = "Disconnect"
End Sub

Private Sub cmdRefresh_Click()
    Dim lvItem As ListItem
    Dim nMessageCount As Long
    Dim nMessage As Long
    Dim strFrom As String
    Dim strSubject As String
    Dim strDate As String
    
    cmdConnect.Enabled = False
    cmdRefresh.Enabled = False
    cmdView.Enabled = False
    comboMailbox.Enabled = False
    
    nMessageCount = ImapClient1.MessageCount
    
    listMessages.ListItems.Clear
    If nMessageCount > 0 Then ProgressBar1.Max = nMessageCount
    ProgressBar1.Value = 0
        
    For nMessage = 1 To nMessageCount
        lblStatus.Caption = "Checking message " & nMessage & " of " & nMessageCount
        lblStatus.Refresh
        
        strFrom = ""
        strSubject = ""
        strDate = ""
        
        ImapClient1.GetHeader nMessage, 0, "From", strFrom
        ImapClient1.GetHeader nMessage, 0, "Subject", strSubject
        ImapClient1.GetHeader nMessage, 0, "Date", strDate
        
        Set lvItem = listMessages.ListItems.Add(, , strFrom)
        lvItem.SubItems(lvcSubject) = strSubject
        lvItem.SubItems(lvcDate) = strDate
    
        ProgressBar1.Value = nMessage
        ProgressBar1.Refresh
        DoEvents
    Next
    
    lblStatus.Caption = "You have " & nMessageCount & " messages in this mailbox"
    lblStatus.Refresh

    ProgressBar1.Value = 0
    ProgressBar1.Max = 100
    
    cmdConnect.Enabled = True
    cmdRefresh.Enabled = True
    cmdView.Enabled = True
    comboMailbox.Enabled = True
End Sub

Private Sub cmdView_Click()
    Dim nMessage As Long
    Dim strMessage As String
    Dim nError As Long
    
    If cmdView.Caption = "View" Then
        nMessage = listMessages.SelectedItem.Index
        
        lblStatus.Caption = "Retrieving message " & nMessage & " from server"
        lblStatus.Refresh
        
        cmdConnect.Enabled = False
        cmdRefresh.Enabled = False
        cmdView.Enabled = False
        ProgressBar1.Max = 100
        ProgressBar1.Value = 0
        
        nError = ImapClient1.GetMessage(nMessage, 0, strMessage)
        If nError <> 0 Then
            lblStatus.Caption = ImapClient1.LastErrorString
            MsgBox ImapClient1.LastErrorString, vbExclamation
            cmdConnect.Enabled = True
            cmdView.Enabled = True
            cmdRefresh.Enabled = True
            ProgressBar1.Value = 0
            Exit Sub
        End If
        
        cmdConnect.Enabled = True
        cmdView.Enabled = True
        cmdView.Caption = "Close"
        ProgressBar1.Value = 0
        listMessages.Visible = False
        textMessage.Text = strMessage
        textMessage.Visible = True
        textMessage.SetFocus
        lblStatus.Caption = "Viewing message " & nMessage & " (" & Len(strMessage) & " bytes)"
    Else
        cmdView.Caption = "View"
        cmdRefresh.Enabled = True
        textMessage.Text = ""
        textMessage.Visible = False
        listMessages.Visible = True
        listMessages.SetFocus
        lblStatus.Caption = ""
    End If
End Sub

Private Sub comboMailbox_Click()
    Dim strMailbox As String
    Dim nError As Long
    
    If cmdView.Caption <> "View" Then
        cmdView_Click
    End If
    
    strMailbox = comboMailbox.List(comboMailbox.ListIndex)
    
    nError = ImapClient1.SelectMailbox(strMailbox)
    If nError <> 0 Then
        lblStatus.Caption = ImapClient1.LastErrorString
        MsgBox ImapClient1.LastErrorString, vbExclamation
        comboMailbox.ListIndex = -1
        Exit Sub
    End If
    
    cmdRefresh_Click
End Sub

Private Sub listMessages_DblClick()
    If listMessages.ListItems.Count > 0 And cmdView.Enabled Then
        cmdView_Click
    End If
End Sub

Private Sub ImapClient1_OnProgress(ByVal MessageNumber As Variant, ByVal MessageSize As Variant, ByVal MessageCopied As Variant, ByVal Percent As Variant)
    ProgressBar1.Value = Percent
End Sub
