VERSION 5.00
Object = "{55BA08D8-B534-486B-A6BA-9B0E78436E57}#1.0#0"; "csnvtx10.ocx"
Object = "{3D985D0B-B512-4BC4-A24A-F391A936B3A2}#1.0#0"; "csrshx10.ocx"
Begin VB.Form frmMain 
   Caption         =   "SocketTools Remote Login Example"
   ClientHeight    =   4440
   ClientLeft      =   4050
   ClientTop       =   2850
   ClientWidth     =   7365
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4440
   ScaleWidth      =   7365
   StartUpPosition =   2  'CenterScreen
   Begin RshClientCtl.RshClient RemoteLogin1 
      Left            =   120
      Top             =   3960
      _cx             =   741
      _cy             =   741
   End
   Begin VB.TextBox Username 
      Height          =   285
      Left            =   3780
      TabIndex        =   3
      Top             =   90
      Width           =   2175
   End
   Begin VB.TextBox Hostname 
      Height          =   285
      Left            =   630
      TabIndex        =   1
      Top             =   90
      Width           =   2085
   End
   Begin VB.CommandButton ConnectBtn 
      Caption         =   "&Connect"
      Height          =   315
      Left            =   6030
      TabIndex        =   4
      Top             =   75
      Width           =   1245
   End
   Begin TerminalCtl.Terminal Terminal1 
      Height          =   3255
      Left            =   0
      TabIndex        =   5
      Top             =   600
      Width           =   7095
      _cx             =   12515
      _cy             =   5741
      AutoRefresh     =   -1  'True
      AutoSelect      =   0   'False
      AutoWrap        =   -1  'True
      BackColor       =   16777215
      BoldColor       =   10485760
      Bell            =   -1  'True
      Columns         =   80
      Cursor          =   -1  'True
      CursorStyle     =   0
      Enabled         =   -1  'True
      Emulation       =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   -2147483640
      MousePointer    =   0
      NewLine         =   0
      Rows            =   25
      ScrollBars      =   3
   End
   Begin VB.Label Label2 
      Caption         =   "&Username:"
      Height          =   225
      Left            =   2790
      TabIndex        =   2
      Top             =   120
      Width           =   915
   End
   Begin VB.Label Label1 
      Caption         =   "&Host:"
      Height          =   225
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   465
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

Private Sub ConnectBtn_Click()
    'Main code to establish connection with server to begin rlogin session
    Dim nError As Integer

    'If we are connected, then this button click is intended to disconnect our session
    If RemoteLogin1.IsConnected Then
        'Rename button and Disconnect
        ConnectBtn.Caption = "&Connect"
        RemoteLogin1.Disconnect
    Else
        ConnectBtn.Caption = "&Disconnect"
        ConnectBtn.Enabled = False
        
        RemoteLogin1.Blocking = False
        RemoteLogin1.Terminal = "ansi"
        RemoteLogin1.Hostname = Trim$(Hostname.Text)
        RemoteLogin1.Username = Trim$(Username.Text)
        
        nError = RemoteLogin1.Login() 'Establish connection
        If (nError <> 0) Then
            MsgBox RemoteLogin1.LastErrorString, vbExclamation
        End If
    End If
End Sub

Private Sub Form_Resize()
    'Keep Terminal controls window maximized in main form's user area
    Terminal1.Top = ConnectBtn.Top + ConnectBtn.Height + 60
    Terminal1.Left = 0
    Terminal1.Width = ScaleWidth
    Terminal1.Height = ScaleHeight - Terminal1.Top
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End
End Sub

Private Sub RemoteLogin1_OnConnect()
    'We got a good connection with the server
    'Enable Connect button which is now labeled Disconnect
    ConnectBtn.Enabled = True
End Sub

Private Sub RemoteLogin1_OnDisconnect()
    'Reset control with explicit Disconnect in case we got this event
    'as a result of a broken connection by the server
    Dim nError As Integer
        
        nError = RemoteLogin1.Disconnect
        If (nError <> 0) Then
            MsgBox RemoteLogin1.LastErrorString, vbExclamation
        End If

    'Connect button now should read "Connect"
    ConnectBtn.Caption = "&Connect"
    ConnectBtn.Enabled = True
End Sub

Private Sub RemoteLogin1_OnRead()
    Dim strBuffer As String
    Dim nResult As Long

    Do
        nResult = RemoteLogin1.Read(strBuffer, 1024)
        If nResult < 1 Then Exit Do
        Terminal1.Write strBuffer
    Loop
End Sub

Private Sub Terminal1_KeyMapped(KeyCode As Integer, Shift As Integer, KeyString As String)
    If RemoteLogin1.IsConnected Then
        RemoteLogin1.Write KeyString
    End If
End Sub

Private Sub Terminal1_KeyPress(KeyAscii As Integer)
    If RemoteLogin1.IsConnected Then
        RemoteLogin1.Write Chr(KeyAscii)
    End If
    KeyAscii = 0 'Prevents character from being output by us
End Sub

