VERSION 5.00
Object = "{DAF4834A-31A4-4599-AC23-3BED170D736C}#1.0#0"; "cstimx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools NetTime Example"
   ClientHeight    =   1635
   ClientLeft      =   4755
   ClientTop       =   3960
   ClientWidth     =   4695
   ForeColor       =   &H80000008&
   Icon            =   "NetTime.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1635
   ScaleWidth      =   4695
   StartUpPosition =   2  'CenterScreen
   Begin TimeClientCtl.TimeClient TimeClient1 
      Left            =   180
      Top             =   1020
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ComboBox comboHostName 
      Height          =   315
      Left            =   1020
      TabIndex        =   5
      Top             =   180
      Width           =   3495
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update"
      Height          =   375
      Left            =   2520
      TabIndex        =   4
      Top             =   960
      Width           =   1275
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Get Time"
      Height          =   375
      Left            =   1080
      TabIndex        =   2
      Top             =   960
      Width           =   1275
   End
   Begin VB.Label staticHostName 
      Caption         =   "System:"
      Height          =   255
      Left            =   180
      TabIndex        =   3
      Top             =   180
      Width           =   855
   End
   Begin VB.Label labelNetworkTime 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   1020
      TabIndex        =   1
      Top             =   540
      Width           =   3495
   End
   Begin VB.Label staticTime 
      Caption         =   "Time:"
      Height          =   255
      Left            =   180
      TabIndex        =   0
      Top             =   540
      Width           =   615
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub cmdAction_Click()
    If TimeClient1.Enabled Then
        TimeClient1.Enabled = False
        TimeClient1.Interval = 0
        cmdAction.Caption = "Get Time"
    Else
        TimeClient1.HostName = Trim$(comboHostName.Text)
        TimeClient1.Enabled = True
        TimeClient1.Interval = 1000
        cmdAction.Caption = "Stop"
    End If
End Sub

Private Sub cmdUpdate_Click()
    TimeClient1.HostName = Trim$(comboHostName.Text)
    TimeClient1.SetTime
End Sub

Private Sub comboHostName_Change()
    UpdateForm
End Sub

Private Sub comboHostName_GotFocus()
    comboHostName.SelStart = 0
    comboHostName.SelLength = Len(comboHostName.Text)
End Sub

Private Sub Form_Load()
    '
    ' Initialize control properties
    '
    TimeClient1.AutoResolve = False
    TimeClient1.Enabled = False
    TimeClient1.Interval = 0
    
    comboHostName.AddItem "time-a.nist.gov"
    comboHostName.AddItem "time-b.nist.gov"
    comboHostName.AddItem "time-nw.nist.gov"
    comboHostName.AddItem "time-a.timefreq.bldrdoc.gov"
    comboHostName.AddItem "time-b.timefreq.bldrdoc.gov"
    comboHostName.AddItem "time-c.timefreq.bldrdoc.gov"
    comboHostName.ListIndex = 1
    
    UpdateForm
End Sub

Private Sub TimeClient1_OnTimer()
    TimeClient1.GetTime
    labelNetworkTime.Caption = TimeClient1.SystemDate + " " + TimeClient1.SystemTime + " GMT"
End Sub

Private Sub UpdateForm()
    If Len(comboHostName.Text) > 0 Then
        cmdAction.Enabled = True
        cmdUpdate.Enabled = True
    Else
        cmdAction.Enabled = False
        cmdUpdate.Enabled = False
    End If
End Sub

