VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Object = "{FEAD6C42-22ED-4504-9C14-8D76AE7BD01A}#1.0#0"; "csmsgx10.ocx"
Begin VB.Form formPost 
   Caption         =   "Post Article"
   ClientHeight    =   4290
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7050
   LinkTopic       =   "Form1"
   ScaleHeight     =   4290
   ScaleWidth      =   7050
   StartUpPosition =   1  'CenterOwner
   Begin MailMessageCtl.MailMessage newsMessage 
      Left            =   6300
      Top             =   1320
      _cx             =   741
      _cy             =   741
   End
   Begin VB.TextBox editAuthor 
      Height          =   315
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   3915
   End
   Begin MSComctlLib.StatusBar sbArticle 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   9
      Top             =   4035
      Width           =   7050
      _ExtentX        =   12435
      _ExtentY        =   450
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   315
      Left            =   5640
      TabIndex        =   8
      Top             =   480
      Width           =   1215
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Post"
      Height          =   315
      Left            =   5640
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox editSubject 
      Height          =   315
      Left            =   1200
      TabIndex        =   3
      Top             =   480
      Width           =   3915
   End
   Begin VB.TextBox editGroups 
      Height          =   315
      Left            =   1200
      TabIndex        =   5
      Top             =   840
      Width           =   3915
   End
   Begin RichTextLib.RichTextBox rtfArticle 
      Height          =   2475
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   5895
      _ExtentX        =   10398
      _ExtentY        =   4366
      _Version        =   393217
      BorderStyle     =   0
      Enabled         =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"PostNews.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label labelAuthor 
      Caption         =   "Author:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   975
   End
   Begin VB.Label labelSubject 
      Caption         =   "Subject:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   975
   End
   Begin VB.Label labelGroups 
      Caption         =   "Newsgroups:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   900
      Width           =   975
   End
End
Attribute VB_Name = "formPost"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Public Author As String
Public Subject As String
Public NewsGroups As String
Public Article As String
Public Canceled As Boolean

Private Sub cmdAction_Click()
    Dim strAuthor As String
    Dim strSubject As String
    Dim strNewsGroups As String
    Dim strArticle As String
    
    strAuthor = Trim(editAuthor.Text)
    If Len(strAuthor) = 0 Then
        MsgBox "Please provide your email address", vbInformation
        editAuthor.SetFocus
        Exit Sub
    End If
    
    strSubject = Trim(editSubject.Text)
    If Len(strSubject) = 0 Then
        MsgBox "Please provide a subject for your article", vbInformation
        editSubject.SetFocus
        Exit Sub
    End If
    
    strNewsGroups = Trim(editGroups.Text)
    If Len(strNewsGroups) = 0 Then
        MsgBox "Please specify one or more newsgroups", vbInformation
        editGroups.SetFocus
        Exit Sub
    End If
    
    strArticle = rtfArticle.Text
    If Len(Trim(strArticle)) = 0 Then
        MsgBox "You cannot post an empty article", vbInformation
        rtfArticle.SetFocus
        Exit Sub
    End If
    
    newsMessage.ClearMessage
    newsMessage.SetHeader "From", strAuthor
    newsMessage.SetHeader "Subject", strSubject
    newsMessage.SetHeader "Newsgroups", strNewsGroups
    newsMessage.AppendMessage strArticle
    
    Author = strAuthor
    Subject = strSubject
    NewsGroups = strNewsGroups
    Article = newsMessage.Message
    
    Canceled = False
    Me.Hide
End Sub

Private Sub cmdCancel_Click()
    Canceled = True
    Me.Hide
End Sub

Private Sub editAuthor_GotFocus()
    editAuthor.SelStart = 0
    editAuthor.SelLength = Len(editAuthor.Text)
End Sub

Private Sub editSubject_GotFocus()
    editSubject.SelStart = 0
    editSubject.SelLength = Len(editSubject.Text)
End Sub

Private Sub editGroups_GotFocus()
    editGroups.SelStart = 0
    editGroups.SelLength = Len(editGroups.Text)
End Sub

Private Sub Form_Resize()
    Dim nWidth As Long
    Dim nHeight As Long
    
    If Me.WindowState = vbMinimized Then Exit Sub
    If Me.Height < 5000 Then Me.Height = 5000
    If Me.Width < 5000 Then Me.Width = 5000
    
    nWidth = Me.ScaleWidth
    nHeight = Me.ScaleHeight
    
    cmdAction.Left = nWidth - cmdAction.Width - 100
    cmdCancel.Left = nWidth - cmdCancel.Width - 100
    editAuthor.Width = nWidth - editAuthor.Left - cmdCancel.Width - 200
    editSubject.Width = editAuthor.Width
    editGroups.Width = editAuthor.Width
    rtfArticle.Top = editGroups.Top + editGroups.Height + 200
    rtfArticle.Left = 0
    rtfArticle.Width = nWidth
    rtfArticle.Height = nHeight - rtfArticle.Top - sbArticle.Height
End Sub
