VERSION 5.00
Object = "{1F367BFD-5A96-4D2D-8CC2-47DDE392C934}#1.0#0"; "cstshx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Example"
   ClientHeight    =   4605
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   7215
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4605
   ScaleWidth      =   7215
   StartUpPosition =   2  'CenterScreen
   Begin SshClientCtl.SshClient SshClient1 
      Left            =   5280
      Top             =   120
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   6000
      TabIndex        =   12
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   6000
      TabIndex        =   11
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox editHostPort 
      Height          =   285
      Left            =   4200
      TabIndex        =   9
      Text            =   "22"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox editOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2895
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   1560
      Width           =   6975
   End
   Begin VB.TextBox editCommand 
      Height          =   285
      Left            =   1080
      TabIndex        =   7
      Top             =   1200
      Width           =   6015
   End
   Begin VB.TextBox editPassword 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   1080
      PasswordChar    =   "*"
      TabIndex        =   5
      Top             =   840
      Width           =   2535
   End
   Begin VB.TextBox editUserName 
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Top             =   480
      Width           =   2535
   End
   Begin VB.TextBox editHostName 
      Height          =   285
      Left            =   1080
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label Label5 
      Caption         =   "Port:"
      Height          =   255
      Left            =   3800
      TabIndex        =   8
      Top             =   165
      Width           =   375
   End
   Begin VB.Label Label4 
      Caption         =   "Command:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1230
      Width           =   855
   End
   Begin VB.Label Label3 
      Caption         =   "Password:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   872
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Username:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   516
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Server:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   160
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdOK_Click()
    Dim strHostName As String
    Dim strHostPort As String
    Dim strUserName As String
    Dim strPassword As String
    Dim strCommand As String
    Dim strLine As String
    Dim strOutput As String
    Dim bResult As Boolean
    Dim nError As Long
    
    strHostName = Trim(editHostName.Text)
    If Len(strHostName) > 0 Then
        SshClient1.HostName = strHostName
    Else
        MsgBox "Please specify a server hostname or IP address", vbInformation
        editHostName.SetFocus
        Exit Sub
    End If
    
    strHostPort = Trim(editHostPort.Text)
    If Len(strHostPort) > 0 Then
        SshClient1.RemotePort = Val(strHostPort)
    Else
        MsgBox "Please specify a remote port number", vbInformation
        editHostPort.SetFocus
        Exit Sub
    End If
    
    strUserName = Trim(editUserName.Text)
    If Len(strUserName) > 0 Then
        SshClient1.UserName = strUserName
    Else
        MsgBox "Please specify a user name", vbInformation
        editUserName.SetFocus
        Exit Sub
    End If
    
    strPassword = Trim(editPassword.Text)
    If Len(strPassword) > 0 Then
        SshClient1.Password = strPassword
    Else
        MsgBox "Please specify a password", vbInformation
        editPassword.SetFocus
        Exit Sub
    End If
    
    strCommand = Trim(editCommand.Text)
    If Len(strCommand) > 0 Then
        SshClient1.Command = strCommand
    Else
        MsgBox "Please specify a command to execute on the server", vbInformation
        editCommand.SetFocus
        Exit Sub
    End If
    
    cmdOK.Enabled = False
    editOutput.Text = ""
    
    nError = SshClient1.Connect()
    If nError > 0 Then
        MsgBox SshClient1.LastErrorString, vbExclamation
        cmdOK.Enabled = True
        Exit Sub
    End If
    
    strOutput = ""
    
    Do
        bResult = SshClient1.ReadLine(strLine)
        strOutput = strOutput + strLine + vbCrLf
        DoEvents
    Loop Until bResult = False
    
    SshClient1.Disconnect

    If Len(strOutput) > 32767 Then
        MsgBox "The output returned by the server has exceeded the " & vbCrLf & _
               "capacity of the edit control and will be truncated.", _
               vbInformation
    End If
    
    editOutput.Text = strOutput
    cmdOK.Enabled = True

End Sub

Private Sub cmdCancel_Click()
    If SshClient1.IsConnected Then
        SshClient1.Cancel
    End If
    End
End Sub
