VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Object = "{36D9612B-43DC-4E7E-A26C-8CD009105648}#1.0#0"; "csftpx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Secure Shell Example"
   ClientHeight    =   4710
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7305
   Icon            =   "SecureShell4.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4710
   ScaleWidth      =   7305
   StartUpPosition =   2  'CenterScreen
   Begin FtpClientCtl.FtpClient FtpClient1 
      Left            =   6480
      Top             =   2640
      _cx             =   741
      _cy             =   741
   End
   Begin MSComDlg.CommonDialog cmnDialog 
      Left            =   5940
      Top             =   2640
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame frameMode 
      Caption         =   "Mode"
      Height          =   915
      Left            =   5940
      TabIndex        =   10
      Top             =   3300
      Width           =   1215
      Begin VB.OptionButton optText 
         Caption         =   "Text"
         Height          =   195
         Left            =   120
         TabIndex        =   12
         Top             =   600
         Width           =   855
      End
      Begin VB.OptionButton optBinary 
         Caption         =   "Binary"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   300
         Value           =   -1  'True
         Width           =   975
      End
   End
   Begin VB.CommandButton cmdView 
      Caption         =   "View"
      Height          =   375
      Left            =   5940
      TabIndex        =   9
      Top             =   1620
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   5940
      TabIndex        =   8
      Top             =   2100
      Width           =   1215
   End
   Begin MSComctlLib.ProgressBar pbTransfer 
      Height          =   285
      Left            =   4050
      TabIndex        =   7
      Top             =   4425
      Width           =   3255
      _ExtentX        =   5741
      _ExtentY        =   503
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.ListBox listFiles 
      Height          =   3570
      Left            =   180
      TabIndex        =   6
      Top             =   660
      Width           =   5475
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Height          =   375
      Left            =   5940
      TabIndex        =   5
      Top             =   1140
      Width           =   1215
   End
   Begin VB.CommandButton cmdList 
      Caption         =   "List Files"
      Height          =   375
      Left            =   5940
      TabIndex        =   4
      Top             =   660
      Width           =   1215
   End
   Begin MSComctlLib.StatusBar sbInfo 
      Align           =   2  'Align Bottom
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Top             =   4395
      Width           =   7305
      _ExtentX        =   12885
      _ExtentY        =   556
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin VB.TextBox editDirectory 
      Height          =   315
      Left            =   960
      TabIndex        =   2
      Top             =   180
      Width           =   4695
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   5940
      TabIndex        =   0
      Top             =   180
      Width           =   1215
   End
   Begin VB.Label lblDirectory 
      Caption         =   "&Directory:"
      Height          =   195
      Left            =   180
      TabIndex        =   1
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

Private Const ftpParentDirectory = -1

Private Type ftpFileInfo
    m_strFileName As String
    m_nFileSize As Long
    m_strFileDate As String
    m_strFileOwner As String
    m_strFileGroup As String
    m_nFilePerms As Long
    m_bIsDirectory As Boolean
End Type

Private ftpFileList() As ftpFileInfo
Private nFileCount As Long

Private Sub UpdateForm(ByVal bEnabled As Boolean)
    If FtpClient1.IsConnected Then
        cmdConnect.Caption = "Disconnect"
        cmdConnect.Enabled = True
    Else
        cmdConnect.Caption = "Connect"
        cmdConnect.Enabled = True
    End If
    
    cmdList.Enabled = bEnabled
    cmdDownload.Enabled = bEnabled
    cmdView.Enabled = bEnabled
    editDirectory.Enabled = bEnabled
End Sub

Private Sub Connect()
    Dim nOptions As Long
    Dim nError As Long
    
    If FtpClient1.IsConnected Then Exit Sub
    FtpClient1.Reset
    
    listFiles.Clear
    editDirectory.Text = ""
        
    ' Show the connection dialog and get the information
    ' needed to call FtpConnect
    formConnect.Show vbModal
    If formConnect.Canceled Then Exit Sub
        
    cmdConnect.Enabled = False
        
    nError = FtpClient1.Connect(formConnect.HostName, _
                                formConnect.RemotePort, _
                                formConnect.UserName, _
                                formConnect.Password, _
                                formConnect.Account, _
                                formConnect.Timeout, _
                                formConnect.Options)
    
    If nError <> 0 Then
        MsgBox FtpClient1.LastErrorString, vbExclamation
        UpdateForm False
        Exit Sub
    End If
        
    UpdateFileList
    UpdateForm True
End Sub

Private Sub UpdateFileList()
    Dim strDirectory As String
    Dim strFileName As String
    Dim nFileSize As Long
    Dim strFileDate As String
    Dim strFileOwner As String
    Dim strFileGroup As String
    Dim nFilePerms As Long
    Dim bIsDirectory As Boolean
    Dim nError As Long
    
    ' Update the form and clear the listbox while we are
    ' retrieving the file list from the server
    UpdateForm False
    listFiles.Clear
    sbInfo.SimpleText = ""
    
    ' Clear the current list of files and reset the count
    nFileCount = 0
    ReDim ftpFileList(nFileCount)
    
    ' Update the current working directory that is displayed
    FtpClient1.GetDirectory strDirectory
    editDirectory.Text = strDirectory
    
    ' Open the current working directory; note that it would
    ' be possible to specify wildcards here if desired
    
    nError = FtpClient1.OpenDirectory()
    
    If nError <> 0 Then
        MsgBox FtpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    ' The first entry in the file list will be the parent
    ' directory; this will allow clients to navigate up
    ' the file system
    listFiles.AddItem "[..]"
    listFiles.ItemData(listFiles.NewIndex) = ftpParentDirectory
    
    Do
        nError = FtpClient1.ReadDirectory(strFileName, _
                                          nFileSize, _
                                          strFileDate, _
                                          strFileOwner, _
                                          strFileGroup, _
                                          nFilePerms, _
                                          bIsDirectory)
        
        If nError <> 0 Then Exit Do
        
        ftpFileList(nFileCount).m_strFileName = strFileName
        ftpFileList(nFileCount).m_nFileSize = nFileSize
        ftpFileList(nFileCount).m_strFileDate = strFileDate
        ftpFileList(nFileCount).m_strFileOwner = strFileOwner
        ftpFileList(nFileCount).m_strFileGroup = strFileGroup
        ftpFileList(nFileCount).m_nFilePerms = nFilePerms
        ftpFileList(nFileCount).m_bIsDirectory = bIsDirectory
        
        If strFileName <> "." And strFileName <> ".." Then
            If bIsDirectory Then
                strFileName = "[" + strFileName + "]"
            End If
        
            ' Add the file to the file listbox; because the list may be
            ' sorted, we store the index into the ftpFileList array
            ' as the item data for the new list item
            listFiles.AddItem strFileName
            listFiles.ItemData(listFiles.NewIndex) = nFileCount
        
            ' Increase the size of the ftpFileList array and then
            ' return information about the next file
            nFileCount = nFileCount + 1
            ReDim Preserve ftpFileList(nFileCount)
        End If
    Loop
    
    FtpClient1.CloseDirectory
    UpdateForm True
End Sub

Private Sub FtpClient1_OnProgress(ByVal FileName As Variant, ByVal FileSize As Variant, ByVal BytesCopied As Variant, ByVal Percent As Variant)
    pbTransfer.Value = Percent
End Sub

Private Sub listFiles_Click()
    Dim nIndex As Long
    
    If nFileCount > 0 Then
        nIndex = listFiles.ItemData(listFiles.ListIndex)
        
        ' If the index value is ftpParentDirectory then this
        ' is not an actual file in our file list
        If nIndex = ftpParentDirectory Then
            sbInfo.SimpleText = ""
            Exit Sub
        End If
        
        If ftpFileList(nIndex).m_bIsDirectory Then
            sbInfo.SimpleText = ftpFileList(nIndex).m_strFileName & " is a directory"
        Else
            sbInfo.SimpleText = ftpFileList(nIndex).m_strFileName & ", " & ftpFileList(nIndex).m_nFileSize & " bytes"
        End If
    End If
End Sub

Private Sub listFiles_DblClick()
    Dim nIndex As Long
    Dim nError As Long
    Dim bIsDirectory As Boolean
    Dim strDirectory As String
    
    If listFiles.ListIndex = -1 Then Exit Sub
    
    nIndex = listFiles.ItemData(listFiles.ListIndex)
    If nIndex = ftpParentDirectory Then
        bIsDirectory = True
        strDirectory = ".."
    Else
        bIsDirectory = CBool(ftpFileList(nIndex).m_bIsDirectory)
        If bIsDirectory Then
            strDirectory = ftpFileList(nIndex).m_strFileName
        End If
    End If
    
    If bIsDirectory Then
        UpdateForm False
        
        nError = FtpClient1.ChangeDirectory(strDirectory)
        If nError <> 0 Then
            MsgBox FtpClient1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        UpdateFileList
    Else
        ' If a binary transfer mode has been selected, presume
        ' the user wants to store the file; otherwise display
        ' the contents of the file
        If optBinary.Value Then
            DownloadFile
        Else
            ViewFile
        End If
    End If
End Sub

Private Sub DownloadFile()
    Dim strLocalFile As String
    Dim strRemoteFile As String
    Dim nIndex As Long
    Dim nError As Long
    
    If listFiles.ListIndex = -1 Then Exit Sub
    
    nIndex = listFiles.ItemData(listFiles.ListIndex)
    If ftpFileList(nIndex).m_bIsDirectory Then
        MsgBox "The selected file is a directory", vbExclamation
        Exit Sub
    End If
    
    strRemoteFile = ftpFileList(nIndex).m_strFileName
    
    cmnDialog.CancelError = True
    cmnDialog.FileName = strRemoteFile
    cmnDialog.Filter = "All Files (*.*)|*.*"
    cmnDialog.Flags = cdlOFNOverwritePrompt + cdlOFNPathMustExist + cdlOFNHideReadOnly
    
    On Error GoTo Canceled
    cmnDialog.Action = 2 ' Save As

    On Error GoTo 0
    strLocalFile = cmnDialog.FileName

    UpdateForm False
    pbTransfer.Value = 0

    If optBinary.Value Then
        FtpClient1.FileType = ftpFileTypeImage
    Else
        FtpClient1.FileType = ftpFileTypeASCII
    End If
    
    nError = FtpClient1.GetFile(strLocalFile, strRemoteFile)
    
    If nError = 0 Then
        MsgBox "Download completed successfully", vbInformation
    Else
        MsgBox FtpClient1.LastErrorString, vbExclamation
    End If
    
    pbTransfer.Value = 0
    UpdateForm True

Canceled:
    Exit Sub
End Sub

Private Sub ViewFile()
    Dim strFileName As String
    Dim strBuffer As String
    Dim nIndex As Long
    Dim nResult As Long
    Dim nError As Long

    If listFiles.ListIndex = -1 Then Exit Sub
    nIndex = listFiles.ItemData(listFiles.ListIndex)

    If ftpFileList(nIndex).m_bIsDirectory Then
        MsgBox "The selected file is a directory", vbExclamation
        Exit Sub
    End If
    
    strFileName = ftpFileList(nIndex).m_strFileName

    If optBinary.Value Then
        nResult = MsgBox("Are you sure you want to view a binary file?", vbYesNo + vbQuestion)
        If nResult = vbNo Then Exit Sub
        FtpClient1.FileType = ftpFileTypeImage
    Else
        FtpClient1.FileType = ftpFileTypeASCII
    End If
    
    UpdateForm False
    pbTransfer.Value = 0

    nError = FtpClient1.GetData(strFileName, strBuffer)
    
    If nError <> 0 Then
        MsgBox FtpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
        
    pbTransfer.Value = 0
    
    ' Display the contents of the file that was downloaded
    Load formView
    formView.Caption = strFileName
    formView.editText.Text = strBuffer
    formView.Show vbModal
    
    UpdateForm True
End Sub

Private Sub Disconnect()
    If FtpClient1.IsConnected Then FtpClient1.Disconnect
    
    listFiles.Clear
    editDirectory.Text = ""
    sbInfo.SimpleText = ""
    
    UpdateForm False
End Sub

Private Sub Form_Load()
    Me.Top = (Screen.Height / 2) - (Me.Height / 2)
    Me.Left = (Screen.Width / 2) - (Me.Width / 2)
    UpdateForm False
End Sub

Private Sub editDirectory_GotFocus()
    editDirectory.SelStart = 0
    editDirectory.SelLength = Len(editDirectory.Text)
End Sub

Private Sub cmdConnect_Click()
    If FtpClient1.IsConnected Then Disconnect Else Connect
End Sub

Private Sub cmdList_Click()
    Dim strDirectory As String
    Dim nError As Long
    
    strDirectory = Trim(editDirectory.Text)
    If Len(strDirectory) = 0 Then
        MsgBox "Please enter a directory name", vbInformation
        editDirectory.SetFocus
        Exit Sub
    End If
    
    UpdateForm False
    
    nError = FtpClient1.ChangeDirectory(strDirectory)
    If nError <> 0 Then
        MsgBox FtpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    UpdateFileList
End Sub

Private Sub cmdDownload_Click()
    DownloadFile
End Sub

Private Sub cmdView_Click()
    ViewFile
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

