VERSION 5.00
Object = "{2A3927E5-D957-4EDB-A00F-DCE43D59E2F9}#1.0#0"; "cstxtx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools"
   ClientHeight    =   4080
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6915
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4080
   ScaleWidth      =   6915
   StartUpPosition =   2  'CenterScreen
   Begin TextMessageCtl.TextMessage TextMessage1 
      Left            =   4560
      Top             =   240
      _cx             =   741
      _cy             =   741
      Password        =   ""
      PhoneNumber     =   ""
      Provider        =   ""
      Relay           =   0   'False
      Secure          =   0   'False
      Sender          =   ""
      ServerName      =   ""
      ServerPort      =   25
      ServiceType     =   1
      Timeout         =   20
      Urgent          =   0   'False
      UserName        =   ""
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   450
      Left            =   5280
      TabIndex        =   10
      Top             =   1320
      Width           =   1400
   End
   Begin VB.CommandButton cmdOptions 
      Caption         =   "Options"
      Height          =   450
      Left            =   5280
      TabIndex        =   9
      Top             =   780
      Width           =   1400
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Default         =   -1  'True
      Height          =   450
      Left            =   5280
      TabIndex        =   8
      Top             =   240
      Width           =   1400
   End
   Begin VB.TextBox txtMessage 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2175
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Top             =   1900
      Width           =   6900
   End
   Begin VB.Frame Frame1 
      Caption         =   "Message"
      Height          =   1695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
      Begin VB.ComboBox comboCarrier 
         Height          =   315
         Left            =   840
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   1095
         Width           =   3255
      End
      Begin VB.TextBox txtPhoneNumber 
         Height          =   315
         Left            =   840
         TabIndex        =   4
         Top             =   680
         Width           =   3255
      End
      Begin VB.TextBox txtSender 
         Height          =   315
         Left            =   840
         TabIndex        =   2
         Top             =   260
         Width           =   3255
      End
      Begin VB.Label Label3 
         Caption         =   "Carrier:"
         Height          =   255
         Left            =   160
         TabIndex        =   5
         Top             =   1140
         Width           =   550
      End
      Begin VB.Label Label2 
         Caption         =   "Phone:"
         Height          =   255
         Left            =   165
         TabIndex        =   3
         Top             =   720
         Width           =   550
      End
      Begin VB.Label Label1 
         Caption         =   "From:"
         Height          =   255
         Left            =   160
         TabIndex        =   1
         Top             =   300
         Width           =   550
      End
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    Dim nIndex As Long
    
    comboCarrier.AddItem "Default"
    
    With TextMessage1
        For nIndex = 0 To .ProviderCount - 1
            comboCarrier.AddItem .ProviderName(nIndex)
        Next
    End With

    comboCarrier.ListIndex = 0
End Sub

Private Sub UpdateForm(bEnabled As Boolean)
    cmdSend.Enabled = bEnabled
    cmdOptions.Enabled = bEnabled
    cmdClose.Enabled = bEnabled

    If bEnabled Then
        Me.MousePointer = vbArrow
    Else
        Me.MousePointer = vbHourglass
    End If
End Sub

Private Sub cmdSend_Click()
    Dim nError As Long
    
    With TextMessage1
        .Sender = Trim(txtSender.Text)
        .PhoneNumber = Trim(txtPhoneNumber.Text)
        .Message = Trim(txtMessage.Text)
        
        If comboCarrier.ListIndex = 0 Then
            .Provider = ""
        Else
            .Provider = comboCarrier.Text
        End If
        
        UpdateForm False
        
        nError = .SendMessage()
        
        UpdateForm True
        
        If nError = 0 Then
            MsgBox "The message was sent successfully", vbInformation, "SocketTools"
        Else
            MsgBox .LastErrorString & vbCrLf & _
                   "You may need to use a relay server to send the message", _
                   vbInformation, "Error"
        End If
    End With
End Sub

Private Sub cmdOptions_Click()
    formOptions.Show vbModal
End Sub

Private Sub cmdClose_Click()
    End
End Sub
