VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{5ED042DA-96A9-4014-8EEF-E0840D215B54}#1.0#0"; "cshtpx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools WebTransfer Example"
   ClientHeight    =   5340
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7770
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5340
   ScaleWidth      =   7770
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin HttpClientCtl.HttpClient HttpClient1 
      Left            =   6060
      Top             =   2100
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   435
      Left            =   6060
      TabIndex        =   20
      Top             =   1380
      Width           =   1455
   End
   Begin VB.CommandButton cmdUpload 
      Caption         =   "Upload"
      Height          =   435
      Left            =   6060
      TabIndex        =   19
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Height          =   435
      Left            =   6060
      TabIndex        =   18
      Top             =   300
      Width           =   1455
   End
   Begin VB.TextBox editOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   180
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   17
      Top             =   3540
      Width           =   5655
   End
   Begin VB.Frame frameTransfer 
      Caption         =   "File Transfer"
      Height          =   1515
      Left            =   180
      TabIndex        =   10
      Top             =   1920
      Width           =   5655
      Begin MSComctlLib.ProgressBar ProgressBar1 
         Height          =   315
         Left            =   1080
         TabIndex        =   16
         Top             =   1080
         Width           =   3075
         _ExtentX        =   5424
         _ExtentY        =   556
         _Version        =   393216
         Appearance      =   1
      End
      Begin VB.TextBox editRemoteFile 
         Height          =   315
         Left            =   1080
         TabIndex        =   14
         Top             =   660
         Width           =   3075
      End
      Begin VB.TextBox editLocalFile 
         Height          =   315
         Left            =   1080
         TabIndex        =   12
         Top             =   240
         Width           =   3075
      End
      Begin VB.Label lblTransfer 
         Height          =   195
         Left            =   4260
         TabIndex        =   21
         Top             =   1140
         Width           =   1275
      End
      Begin VB.Label Label7 
         Caption         =   "Progress:"
         Height          =   195
         Left            =   120
         TabIndex        =   15
         Top             =   1140
         Width           =   795
      End
      Begin VB.Label Label6 
         Caption         =   "&Remote File:"
         Height          =   195
         Left            =   120
         TabIndex        =   13
         Top             =   720
         Width           =   915
      End
      Begin VB.Label Label5 
         Caption         =   "&Local File:"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   300
         Width           =   795
      End
   End
   Begin VB.Frame frameConnection 
      Caption         =   "Connection"
      Height          =   1635
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   5655
      Begin VB.CheckBox chkSecure 
         Caption         =   "Secure"
         Height          =   195
         Left            =   4320
         TabIndex        =   9
         Top             =   780
         Width           =   975
      End
      Begin VB.TextBox editPassword 
         Height          =   315
         IMEMode         =   3  'DISABLE
         Left            =   1080
         PasswordChar    =   "*"
         TabIndex        =   8
         Top             =   1140
         Width           =   3075
      End
      Begin VB.TextBox editUserName 
         Height          =   315
         Left            =   1080
         TabIndex        =   6
         Top             =   720
         Width           =   3075
      End
      Begin VB.TextBox editRemotePort 
         Height          =   315
         Left            =   4740
         TabIndex        =   4
         Text            =   "80"
         Top             =   300
         Width           =   555
      End
      Begin VB.TextBox editRemoteHost 
         Height          =   315
         Left            =   1080
         TabIndex        =   2
         Top             =   300
         Width           =   3075
      End
      Begin VB.Label Label4 
         Caption         =   "&Password:"
         Height          =   195
         Left            =   120
         TabIndex        =   7
         Top             =   1200
         Width           =   795
      End
      Begin VB.Label Label3 
         Caption         =   "&Port:"
         Height          =   195
         Left            =   4320
         TabIndex        =   3
         Top             =   360
         Width           =   435
      End
      Begin VB.Label Label2 
         Caption         =   "&User Name:"
         Height          =   195
         Left            =   120
         TabIndex        =   5
         Top             =   780
         Width           =   915
      End
      Begin VB.Label Label1 
         Caption         =   "&Host Name:"
         Height          =   195
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   915
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub UpdateForm(ByVal bEnabled As Boolean)
    cmdDownload.Enabled = bEnabled
    cmdUpload.Enabled = bEnabled
    cmdClose.Enabled = bEnabled
End Sub

Private Sub chkSecure_Click()
    If chkSecure.Value = vbChecked Then
        editRemotePort.Text = CStr(httpPortSecure)
    Else
        editRemotePort.Text = CStr(httpPortDefault)
    End If
End Sub

Private Sub Form_Load()
    UpdateForm True
End Sub

Private Sub editOutput_KeyPress(KeyAscii As Integer)
    If KeyAscii <> 3 Then KeyAscii = 0
End Sub

Private Sub editRemoteHost_GotFocus()
    editRemoteHost.SelStart = 0
    editRemoteHost.SelLength = Len(editRemoteHost.Text)
End Sub

Private Sub editRemotePort_GotFocus()
    editRemotePort.SelStart = 0
    editRemotePort.SelLength = Len(editRemotePort.Text)
End Sub

Private Sub editUserName_GotFocus()
    editUserName.SelStart = 0
    editUserName.SelLength = Len(editUserName.Text)
End Sub

Private Sub editPassword_GotFocus()
    editPassword.SelStart = 0
    editPassword.SelLength = Len(editPassword.Text)
End Sub

Private Sub editLocalFile_GotFocus()
    editLocalFile.SelStart = 0
    editLocalFile.SelLength = Len(editLocalFile.Text)
End Sub

Private Sub editRemoteFile_GotFocus()
    editRemoteFile.SelStart = 0
    editRemoteFile.SelLength = Len(editRemoteFile.Text)
End Sub

Private Sub cmdDownload_Click()
    Dim strRemoteHost As String
    Dim nRemotePort As Long
    Dim strLocalFile As String
    Dim strRemoteFile As String
    Dim nError As Long
    
    strRemoteHost = Trim(editRemoteHost.Text)
    If Len(strRemoteHost) = 0 Then
        MsgBox "Please enter the name of the server", vbInformation
        editRemoteHost.SetFocus
        Exit Sub
    End If
    
    nRemotePort = CLng(editRemotePort.Text)
    If nRemotePort < 1 Or nRemotePort > 65535 Then
        MsgBox "Please enter a valid port number", vbInformation
        editRemotePort.SetFocus
        Exit Sub
    End If
    
    strLocalFile = Trim(editLocalFile.Text)
    If Len(strLocalFile) = 0 Then
        MsgBox "Please enter a file name", vbInformation
        editLocalFile.SetFocus
        Exit Sub
    End If
    
    strRemoteFile = Trim(editRemoteFile.Text)
    If Len(strRemoteFile) = 0 Then
        MsgBox "Please enter a file name", vbInformation
        editRemoteFile.SetFocus
        Exit Sub
    End If
    
    HttpClient1.HostName = strRemoteHost
    HttpClient1.RemotePort = nRemotePort
    HttpClient1.UserName = Trim(editUserName.Text)
    HttpClient1.Password = Trim(editPassword.Text)
    HttpClient1.Timeout = 15
    
    If chkSecure.Value = vbChecked Then
        HttpClient1.Secure = True
    End If
    
    editOutput.Text = ""
    ProgressBar1.Value = 0
    UpdateForm False
    
    nError = HttpClient1.Connect()
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    nError = HttpClient1.GetFile(strLocalFile, strRemoteFile)
    If nError = 0 Then
        MsgBox "Download completed successfully", vbInformation
    Else
        MsgBox HttpClient1.LastErrorString, vbExclamation
    End If

    HttpClient1.Disconnect
    ProgressBar1.Value = 0
    UpdateForm True
End Sub

Private Sub cmdUpload_Click()
    Dim strRemoteHost As String
    Dim nRemotePort As Long
    Dim strLocalFile As String
    Dim strRemoteFile As String
    Dim nError As Long
    
    strRemoteHost = Trim(editRemoteHost.Text)
    If Len(strRemoteHost) = 0 Then
        MsgBox "Please enter the name of the server", vbInformation
        editRemoteHost.SetFocus
        Exit Sub
    End If
    
    nRemotePort = CLng(editRemotePort.Text)
    If nRemotePort < 1 Or nRemotePort > 65535 Then
        MsgBox "Please enter a valid port number", vbInformation
        editRemotePort.SetFocus
        Exit Sub
    End If
    
    strLocalFile = Trim(editLocalFile.Text)
    If Len(strLocalFile) = 0 Then
        MsgBox "Please enter a file name", vbInformation
        editLocalFile.SetFocus
        Exit Sub
    End If
    
    strRemoteFile = Trim(editRemoteFile.Text)
    If Len(strRemoteFile) = 0 Then
        MsgBox "Please enter a file name", vbInformation
        editRemoteFile.SetFocus
        Exit Sub
    End If
    
    editOutput.Text = ""
    ProgressBar1.Value = 0
    UpdateForm False
    
    HttpClient1.HostName = strRemoteHost
    HttpClient1.RemotePort = nRemotePort
    HttpClient1.UserName = Trim(editUserName.Text)
    HttpClient1.Password = Trim(editPassword.Text)
    HttpClient1.Timeout = 15
    
    If chkSecure.Value = vbChecked Then
        HttpClient1.Secure = True
    End If
    
    editOutput.Text = ""
    ProgressBar1.Value = 0
    UpdateForm False
    
    nError = HttpClient1.Connect()
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    nError = HttpClient1.PutFile(strLocalFile, strRemoteFile)
    If nError = 0 Then
        MsgBox "Upload completed successfully", vbInformation
    Else
        MsgBox HttpClient1.LastErrorString, vbExclamation
    End If

    HttpClient1.Disconnect
    ProgressBar1.Value = 0
    UpdateForm True
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub HttpClient1_OnCommand(ByVal ResultCode As Variant, ByVal ResultString As Variant)
    editOutput.SelStart = Len(editOutput.Text)
    editOutput.SelText = ResultCode & " " & ResultString & vbCrLf
End Sub

Private Sub HttpClient1_OnProgress(ByVal BytesTotal As Variant, ByVal BytesCopied As Variant, ByVal Percent As Variant)
    ProgressBar1.Value = Percent
    lblTransfer.Caption = BytesCopied & " bytes"
End Sub
