VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ChatClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_nClientId As Long
Private m_strIpAddress As String
Private m_strUserName As String
Private m_timeConnected As Date
Private m_bAuthenticated As Boolean

Public Property Get Address() As String
    Address = m_strIpAddress
End Property

Public Property Get Authenticated() As Boolean
    Authenticated = m_bAuthenticated
End Property

Public Property Get ClientId() As Long
    ClientId = m_nClientId
End Property

Public Property Get Connected() As Date
    Connected = m_timeConnected
End Property

Public Property Get UserName() As String
    UserName = m_strUserName
End Property

Public Sub Initialize(ClientId As Long, ClientAddress As String)
    m_nClientId = ClientId
    m_strIpAddress = ClientAddress
    m_timeConnected = Now
    m_bAuthenticated = False
End Sub

Public Function Authenticate(UserName As String) As Boolean
    Authenticate = False

   ' The username must be at least 2 characters
   If Len(UserName) < 2 Then Exit Function
        
   m_strUserName = UserName
   m_bAuthenticated = True
   
   Authenticate = True
End Function
