VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{140E13F4-3728-476B-8E97-2C939C89B5E8}#1.0#0"; "cspopx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools CheckMail Example"
   ClientHeight    =   7125
   ClientLeft      =   4125
   ClientTop       =   3075
   ClientWidth     =   9165
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7125
   ScaleWidth      =   9165
   Begin PopClientCtl.PopClient PopClient1 
      Left            =   6960
      Top             =   180
      _cx             =   741
      _cy             =   741
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   315
      Left            =   5640
      TabIndex        =   13
      Top             =   6780
      Width           =   3435
      _ExtentX        =   6059
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdView 
      Caption         =   "View"
      Enabled         =   0   'False
      Height          =   375
      Left            =   7800
      TabIndex        =   9
      Top             =   540
      Width           =   1215
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Enabled         =   0   'False
      Height          =   375
      Left            =   7800
      TabIndex        =   10
      Top             =   1020
      Width           =   1215
   End
   Begin VB.TextBox txtPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1320
      PasswordChar    =   "*"
      TabIndex        =   5
      Top             =   1020
      Width           =   3375
   End
   Begin VB.TextBox txtUserName 
      Height          =   315
      Left            =   1320
      TabIndex        =   3
      Top             =   600
      Width           =   3375
   End
   Begin VB.TextBox txtServer 
      Height          =   315
      Left            =   1320
      TabIndex        =   1
      Top             =   180
      Width           =   3375
   End
   Begin VB.CommandButton cmdCheckMail 
      Caption         =   "Check Mail"
      Default         =   -1  'True
      Height          =   375
      Left            =   7800
      TabIndex        =   8
      Top             =   60
      Width           =   1215
   End
   Begin VB.TextBox txtPort 
      Height          =   315
      Left            =   5340
      TabIndex        =   7
      Text            =   "110"
      Top             =   180
      Width           =   555
   End
   Begin VB.TextBox txtMessage 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5175
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   14
      Top             =   1560
      Visible         =   0   'False
      Width           =   9015
   End
   Begin MSComctlLib.ListView listMessages 
      Height          =   5235
      Left            =   60
      TabIndex        =   11
      Top             =   1500
      Width           =   9015
      _ExtentX        =   15901
      _ExtentY        =   9234
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   60
      TabIndex        =   12
      Top             =   6780
      Width           =   5595
   End
   Begin VB.Label lblPassword 
      Caption         =   "Password:"
      Height          =   195
      Left            =   360
      TabIndex        =   4
      Top             =   1080
      Width           =   915
   End
   Begin VB.Label lblUserName 
      Caption         =   "User Name:"
      Height          =   195
      Left            =   360
      TabIndex        =   2
      Top             =   660
      Width           =   915
   End
   Begin VB.Label lblPort 
      Caption         =   "Port:"
      Height          =   195
      Left            =   4860
      TabIndex        =   6
      Top             =   240
      Width           =   435
   End
   Begin VB.Label lblServer 
      Caption         =   "Mail Server:"
      Height          =   195
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   915
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

' ListView column header constants
Private Const lvcSubject = 1
Private Const lvcDate = 2

Private Sub Form_Load()
    Dim colHeader As ColumnHeader
    
    ProgressBar1.Value = 0
    
    listMessages.View = lvwReport
    Set colHeader = listMessages.ColumnHeaders.Add(, , "From", 1600)
    Set colHeader = listMessages.ColumnHeaders.Add(, , "Subject", 4550)
    Set colHeader = listMessages.ColumnHeaders.Add(, , "Date", 2500)
End Sub

Private Function GetHeaderValue(ByVal strHeaders As String, ByVal strHeaderName As String) As String
    Dim nPos1 As Long
    Dim nPos2 As Long
    Dim nStart As Long
    
    nPos1 = InStr(strHeaders, strHeaderName & ":")
    If nPos1 = 0 Then
        GetHeaderValue = ""
        Exit Function
    End If
    
    strHeaders = Right(strHeaders, (Len(strHeaders) - nPos1) + 1)
    
    nPos1 = InStr(strHeaders, " ")
    nStart = 1
    Do
        nPos2 = InStr(nStart, strHeaders, Chr(13) & Chr(10))
        nStart = nPos2 + 3
        ' If there is a tab after the <crlf>, the header is multi-line
        ' so find the end of the next line
    Loop While (Mid(strHeaders, nPos2 + 2, 1) = Chr(9))
    
    If nPos1 < nPos2 Then
        GetHeaderValue = Mid(strHeaders, nPos1 + 1, (nPos2 - nPos1) - 1)
    Else
        GetHeaderValue = ""
    End If
    
End Function

Private Sub cmdCheckMail_Click()
    Dim lvItem As ListItem
    Dim strHeaders As String
    Dim nMessages As Long
    Dim nIndex As Long
    Dim nResult As Long
    
    ProgressBar1.Value = 0
    PopClient1.HostName = Trim(txtServer.Text)
    PopClient1.UserName = Trim(txtUserName.Text)
    PopClient1.Password = Trim(txtPassword.Text)
    
    nResult = PopClient1.Connect()
    If nResult <> 0 Then
        MsgBox PopClient1.LastErrorString, vbExclamation
        PopClient1.Disconnect
        Exit Sub
    End If

    On Error Resume Next: Err.Clear
    nMessages = PopClient1.MessageCount
    If Err.Number <> 0 Then
        MsgBox PopClient1.LastErrorString, vbExclamation
        PopClient1.Disconnect
        Exit Sub
    End If
    On Error GoTo 0
        
    If (nMessages <> 0) Then
        cmdDelete.Enabled = True
        cmdView.Enabled = True
    Else
        cmdDelete.Enabled = False
        cmdView.Enabled = False
    End If
    
    listMessages.ListItems.Clear
    
    For nIndex = 1 To PopClient1.LastMessage
        lblStatus.Caption = "Downloading Message " & nIndex & " Headers"
        ProgressBar1.Value = CLng((CDbl(nIndex) / CDbl(nMessages)) * 100#)
        lblStatus.Refresh
        
        nResult = PopClient1.GetHeaders(nIndex, strHeaders)
       
        Set lvItem = listMessages.ListItems.Add(, , GetHeaderValue(strHeaders, "From"))
        lvItem.SubItems(lvcSubject) = GetHeaderValue(strHeaders, "Subject")
        lvItem.SubItems(lvcDate) = GetHeaderValue(strHeaders, "Date")
    Next
    
    lblStatus.Caption = "You have " & nMessages & " messages."
    lblStatus.Refresh
    
    PopClient1.Disconnect
End Sub

Private Sub cmdDelete_Click()
    Dim lvItem As ListItem
    Dim bSelected As Boolean
    Dim nResult As Long
    Dim nIndex As Long
    
    bSelected = False
    
    If MsgBox("Are you sure you want to delete these messages?", vbQuestion + vbYesNo, App.Title) = vbNo Then
        listMessages.SetFocus
        Exit Sub
    End If
    
    PopClient1.HostName = Trim(txtServer.Text)
    PopClient1.UserName = Trim(txtUserName.Text)
    PopClient1.Password = Trim(txtPassword.Text)
    
    nResult = PopClient1.Connect
    If nResult <> 0 Then
        MsgBox PopClient1.LastErrorString, vbExclamation
        PopClient1.Disconnect
        Exit Sub
    End If
    
    For nIndex = listMessages.ListItems.Count To 1 Step -1
        If listMessages.ListItems(nIndex).Selected = True Then
            nResult = PopClient1.DeleteMessage(nIndex)
            If nResult <> 0 Then
                MsgBox PopClient1.LastErrorString, vbExclamation
                PopClient1.Disconnect
                Exit Sub
            End If
            bSelected = True
        End If
    Next
    
    PopClient1.Disconnect
    listMessages.SetFocus
    
    If (bSelected) Then
        'If messages were deleted, then use cmdCheckMail to redisplay messages
        cmdCheckMail_Click
    Else
        MsgBox "No messages were selected."
    End If
    
    listMessages.SetFocus

End Sub

Private Sub cmdView_Click()
    Dim nMessage As Long
    Dim strMessage As String
    Dim nError As Long
    
    If (cmdView.Caption = "Close") Then
        listMessages.Visible = True
        txtMessage.Visible = False
        cmdDelete.Enabled = True
        cmdCheckMail.Enabled = True
        cmdView.Caption = "View"
        txtMessage.Text = ""
        listMessages.SetFocus
    Else
        cmdCheckMail.Enabled = False
    
        For nMessage = 1 To listMessages.ListItems.Count
            If (listMessages.ListItems(nMessage).Selected = True) Then
                Exit For
            End If
        Next
    
        PopClient1.HostName = Trim(txtServer.Text)
        PopClient1.UserName = Trim(txtUserName.Text)
        PopClient1.Password = Trim(txtPassword.Text)
        
        nError = PopClient1.Connect()
        If nError <> 0 Then
            MsgBox PopClient1.LastErrorString, vbExclamation
            PopClient1.Disconnect
            Exit Sub
        End If
        
        'Get the entire message and put it in strMessage
        nError = PopClient1.GetMessage(nMessage, strMessage)
        If nError <> 0 Then
            MsgBox PopClient1.LastErrorString, vbExclamation
            PopClient1.Disconnect
            Exit Sub
        End If

        PopClient1.Disconnect
    
        listMessages.Visible = False
        txtMessage.Visible = True
        cmdDelete.Enabled = False
        cmdView.Caption = "Close"
        txtMessage.Text = strMessage 'Put the message in the text box
    End If

End Sub

Private Sub listMessages_DblClick()
    If listMessages.ListItems.Count > 0 Then cmdView_Click
End Sub

