VERSION 5.00
Object = "{55BA08D8-B534-486B-A6BA-9B0E78436E57}#1.0#0"; "csnvtx10.ocx"
Object = "{3D985D0B-B512-4BC4-A24A-F391A936B3A2}#1.0#0"; "csrshx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools - Remote Command Example"
   ClientHeight    =   5550
   ClientLeft      =   3300
   ClientTop       =   2670
   ClientWidth     =   7980
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5550
   ScaleWidth      =   7980
   Begin RshClientCtl.RshClient RshClient1 
      Left            =   120
      Top             =   5040
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ComboBox RemotePort 
      Height          =   315
      Left            =   5040
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   60
      Width           =   2775
   End
   Begin VB.TextBox RemoteCommand 
      Height          =   285
      Left            =   1170
      TabIndex        =   9
      Top             =   780
      Width           =   6645
   End
   Begin VB.TextBox Password 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   5040
      PasswordChar    =   "*"
      TabIndex        =   7
      Top             =   420
      Width           =   2775
   End
   Begin VB.TextBox UserName 
      Height          =   285
      Left            =   1170
      TabIndex        =   5
      Top             =   420
      Width           =   2685
   End
   Begin VB.TextBox HostName 
      Height          =   285
      Left            =   1170
      TabIndex        =   1
      Top             =   90
      Width           =   2685
   End
   Begin VB.CommandButton ExecuteButton 
      Caption         =   "Execute"
      Height          =   405
      Left            =   3330
      TabIndex        =   10
      Top             =   5010
      Width           =   1335
   End
   Begin TerminalCtl.Terminal Terminal1 
      Height          =   3555
      Left            =   0
      TabIndex        =   11
      Top             =   1200
      Width           =   7935
      _cx             =   13996
      _cy             =   6271
      AutoRefresh     =   -1  'True
      AutoSelect      =   0   'False
      AutoWrap        =   -1  'True
      BackColor       =   16777215
      BoldColor       =   10485760
      Bell            =   -1  'True
      Columns         =   80
      Cursor          =   -1  'True
      CursorStyle     =   0
      Enabled         =   -1  'True
      Emulation       =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   -2147483640
      MousePointer    =   0
      NewLine         =   2
      Rows            =   25
      ScrollBars      =   3
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   4080
      TabIndex        =   2
      Top             =   120
      Width           =   330
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Command:"
      Height          =   195
      Left            =   150
      TabIndex        =   8
      Top             =   810
      Width           =   750
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Password:"
      Height          =   195
      Left            =   4080
      TabIndex        =   6
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Username:"
      Height          =   195
      Left            =   150
      TabIndex        =   4
      Top             =   450
      Width           =   765
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Hostname:"
      Height          =   195
      Left            =   150
      TabIndex        =   0
      Top             =   120
      Width           =   765
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub ExecuteButton_Click()
    'Code here will establish a connection with remote command server
    'and submit the user entered command. Any results are displayed
    'in the terminal control's window.
    
    Dim nError As Integer

    'ExecuteButton's caption is changed to "Disconnect" in
    'RemoteCmd control's Connect event. If we are Connected,
    'then user must want to Disconnect now
    If RshClient1.IsConnected Then
        'Disconnect from server
        nError = RshClient1.Disconnect
        If (nError <> 0) Then
            MsgBox "Unable to disconnect.  Error: " & nError
        End If
        'Switch button back to Execute for next command
        ExecuteButton.Caption = "Execute"
    Else
        'User is ready to execute command on server
        'We want to receive data from server asyncronously. Setting
        'Blocking to False will cause Read event to be generated when
        'data comes from server.
        RshClient1.Blocking = False
        RshClient1.Terminal = "ansi"
        
        'Setup HostName, Username and Password properties for authentication
        RshClient1.HostName = Trim$(HostName.Text)
        RshClient1.UserName = Trim$(UserName.Text)
        RshClient1.Password = Trim$(Password.Text)
        RshClient1.RemotePort = RemotePort.ItemData(RemotePort.ListIndex)
        
        'Set command to be executed
        RshClient1.Command = Trim$(RemoteCommand.Text)
    
        If Len(RshClient1.Command) = 0 Then
            MsgBox "No command to execute on remote host"
            Exit Sub
        End If

        If RemotePort.ListIndex = 0 Then
            'User has selected "rexec" method of execution which requires
            'a password to authenticate
            If Len(RshClient1.Password) = 0 Then
                MsgBox "A password is required to execute this command"
                Exit Sub
            End If
        End If
        
        nError = RshClient1.Execute()
        If (nError <> 0) Then
            MsgBox RshClient1.LastErrorString, vbExclamation
        End If
        
        'Clear our Terminal screen for possible command output
        Terminal1.Clear

        'Button will be re-enabled in the Connect event
        ExecuteButton.Enabled = False
    End If

End Sub

Private Sub Form_Load()
    'This sample employs the Remote Command and Terminal controls.
    'The Terminal control is used to display command execution output.
    'Command is initiated in the ExecuteButton_Click routine

    'Hard coded choices in remote execution methods:
    'exec requires user password authentication
    'shell will run the command with just a username
    RemotePort.AddItem "exec"
    RemotePort.ItemData(0) = rshPortExec
    RemotePort.AddItem "shell"
    RemotePort.ItemData(1) = rshPortShell
    RemotePort.ListIndex = 0
End Sub

Private Sub RshClient1_OnConnect()
    'We're here as a result of a successful connection with our server
    
    'Change Execute button to allow the user to Disconnect
    ExecuteButton.Caption = "Disconnect"
    ExecuteButton.Enabled = True

End Sub

Private Sub RshClient1_OnDisconnect()
    'We're being notified that the connection has been broken
    'either by an explicit Disconnect from us or a break by the server
    Dim nError As Integer

    'A Disconnect may seem redundant, but it cleans things up
    'if we are disconnected as a result of the server
    nError = RshClient1.Disconnect
    If (nError <> 0) Then
        MsgBox "Unable to disconnect.  Error: " & nError
    End If

    'Set button back to Execute another command
    ExecuteButton.Caption = "Execute"
    ExecuteButton.Enabled = True

End Sub

Private Sub RshClient1_OnRead()
    Dim strBuffer As String
    Dim nResult As Long
    
    Do
        nResult = RshClient1.Read(strBuffer, 1024)
        If nResult < 1 Then Exit Do
        Terminal1.Write strBuffer
    Loop
End Sub

