VERSION 5.00
Object = "{1EC6BF9E-61C4-4831-9B61-F356A93B9CB9}#1.0#0"; "cshtsx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools HTTP Server Example"
   ClientHeight    =   5025
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8040
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5025
   ScaleWidth      =   8040
   StartUpPosition =   2  'CenterScreen
   Begin HttpServerCtl.HttpServer HttpServer1 
      Left            =   6600
      Top             =   2400
      _cx             =   741
      _cy             =   741
   End
   Begin VB.Frame frameLogging 
      Caption         =   "Logging"
      Height          =   855
      Left            =   120
      TabIndex        =   27
      Top             =   3720
      Width           =   6135
      Begin VB.TextBox editLogFile 
         Height          =   285
         Left            =   2240
         TabIndex        =   30
         Text            =   "%AppData%\SocketTools\HttpServer.log"
         ToolTipText     =   "The name of the file that will contain a log of client activity"
         Top             =   300
         Width           =   3680
      End
      Begin VB.ComboBox comboFormats 
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   28
         ToolTipText     =   "The format that should be used when logging client activity"
         Top             =   300
         Width           =   1600
      End
      Begin VB.Label lblLogFile 
         Caption         =   "File:"
         Height          =   255
         Left            =   1840
         TabIndex        =   29
         Top             =   340
         Width           =   300
      End
   End
   Begin VB.Frame frameOptions 
      Caption         =   "Options"
      Height          =   1965
      Left            =   120
      TabIndex        =   16
      Top             =   1680
      Width           =   6135
      Begin VB.CheckBox chkLockFiles 
         Caption         =   "Lock Files"
         Height          =   255
         Left            =   3100
         TabIndex        =   24
         ToolTipText     =   "Lock files during transfers"
         Top             =   1380
         Width           =   1650
      End
      Begin VB.CheckBox chkLocalUser 
         Caption         =   "Local Users"
         Height          =   255
         Left            =   140
         TabIndex        =   21
         ToolTipText     =   "Allow clients to authenticate as users on the local Windows system"
         Top             =   720
         Value           =   1  'Checked
         Width           =   1650
      End
      Begin VB.CheckBox chkMultiUser 
         Caption         =   "User Directories"
         Height          =   255
         Left            =   140
         TabIndex        =   23
         ToolTipText     =   "Users should have their own home directories"
         Top             =   1380
         Width           =   1650
      End
      Begin VB.CheckBox chkHidden 
         Caption         =   "Hidden Files"
         Height          =   255
         Left            =   3100
         TabIndex        =   26
         ToolTipText     =   "The server should allow access to hidden files"
         Top             =   1035
         Width           =   1650
      End
      Begin VB.CheckBox chkReadOnly 
         Caption         =   "Read Only"
         Height          =   255
         Left            =   3100
         TabIndex        =   25
         ToolTipText     =   "The server will only permit files to be downloaded"
         Top             =   720
         Width           =   1650
      End
      Begin VB.CheckBox chkRestricted 
         Caption         =   "Restricted Access"
         Height          =   255
         Left            =   140
         TabIndex        =   22
         ToolTipText     =   "Restrict access to the server, limiting the commands that can be used by clients"
         Top             =   1035
         Width           =   1650
      End
      Begin VB.TextBox editIdleTime 
         Height          =   285
         Left            =   3800
         TabIndex        =   20
         Text            =   "30"
         ToolTipText     =   "The number of seconds a client can remain idle before being disconnected"
         Top             =   280
         Width           =   700
      End
      Begin VB.TextBox editMaxClients 
         Height          =   285
         Left            =   1000
         TabIndex        =   18
         Text            =   "1000"
         ToolTipText     =   "The maximum number of client connections allowed"
         Top             =   280
         Width           =   700
      End
      Begin VB.Label lblIdle 
         Caption         =   "Timeout:"
         Height          =   255
         Left            =   3100
         TabIndex        =   19
         Top             =   300
         Width           =   690
      End
      Begin VB.Label lblMaxClients 
         Caption         =   "Clients:"
         Height          =   255
         Left            =   140
         TabIndex        =   17
         Top             =   300
         Width           =   680
      End
   End
   Begin VB.Frame frameServer 
      Caption         =   "Server"
      Height          =   1455
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   6135
      Begin VB.TextBox editDirectory 
         Height          =   315
         Left            =   1000
         TabIndex        =   15
         Text            =   "%AppData%\SocketTools\HttpServer"
         ToolTipText     =   "The root directory for the server where files will be stored"
         Top             =   960
         Width           =   5000
      End
      Begin VB.TextBox editIdentity 
         Height          =   315
         Left            =   3800
         TabIndex        =   8
         Text            =   "SocketTools 10.0"
         ToolTipText     =   "A value that identifies the server application and version"
         Top             =   240
         Width           =   2200
      End
      Begin VB.CheckBox chkSecure 
         Caption         =   "Secure"
         Height          =   255
         Left            =   4560
         TabIndex        =   13
         ToolTipText     =   "Support secure client connections using the SSL and TLS protocols"
         Top             =   620
         Width           =   855
      End
      Begin VB.TextBox editLocalPort 
         Height          =   285
         Left            =   3800
         TabIndex        =   12
         Text            =   "80"
         ToolTipText     =   "The port number the server will use to listen for connections"
         Top             =   620
         Width           =   600
      End
      Begin VB.TextBox editLocalAddress 
         Height          =   315
         Left            =   1000
         TabIndex        =   10
         Text            =   "127.0.0.1"
         ToolTipText     =   "The local IP address that the server will use to listen for connections"
         Top             =   620
         Width           =   2000
      End
      Begin VB.TextBox editHostName 
         Height          =   315
         Left            =   1000
         TabIndex        =   6
         Text            =   "localhost"
         ToolTipText     =   "The fully qualified domain name for the server"
         Top             =   240
         Width           =   2000
      End
      Begin VB.Label lblDirectory 
         Caption         =   "Directory:"
         Height          =   255
         Left            =   140
         TabIndex        =   14
         Top             =   1000
         Width           =   680
      End
      Begin VB.Label lblIdentity 
         Caption         =   "Identity:"
         Height          =   255
         Left            =   3100
         TabIndex        =   7
         Top             =   280
         Width           =   640
      End
      Begin VB.Label lblLocalPort 
         Caption         =   "Port:"
         Height          =   255
         Left            =   3100
         TabIndex        =   11
         Top             =   640
         Width           =   350
      End
      Begin VB.Label lblLocalAddress 
         Caption         =   "Address:"
         Height          =   255
         Left            =   140
         TabIndex        =   9
         Top             =   640
         Width           =   680
      End
      Begin VB.Label lblHostName 
         Caption         =   "Name:"
         Height          =   255
         Left            =   140
         TabIndex        =   5
         Top             =   280
         Width           =   680
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   6600
      TabIndex        =   3
      Top             =   1800
      Width           =   1215
   End
   Begin VB.CommandButton cmdRestart 
      Caption         =   "Restart"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   2
      Top             =   1266
      Width           =   1215
   End
   Begin VB.CommandButton cmdSuspend 
      Caption         =   "Suspend"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   1
      Top             =   733
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   0
      Top             =   200
      Width           =   1215
   End
   Begin VB.Label lblClient 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "0 Clients"
      Height          =   315
      Left            =   6360
      TabIndex        =   32
      Top             =   4680
      Width           =   1605
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   120
      TabIndex        =   31
      Top             =   4680
      Width           =   6285
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    comboFormats.AddItem "None", 0
    comboFormats.AddItem "Common", 1
    comboFormats.AddItem "Extended", 2
    comboFormats.ListIndex = 0
End Sub

Private Sub UpdateForm(ByVal bEnable As Boolean)
    If HttpServer1.IsActive Then
        cmdStart.Enabled = bEnable
        cmdSuspend.Enabled = bEnable
        cmdRestart.Enabled = bEnable
    Else
        cmdStart.Enabled = bEnable
        cmdSuspend.Enabled = False
        cmdRestart.Enabled = False
    End If
End Sub

Private Sub UpdateStatus(strMessage)
    lblStatus.Caption = strMessage
    lblClient.Caption = HttpServer1.ClientCount & " Clients"
End Sub

Private Sub cmdStart_Click()
    Dim nError As Long
    
    If Not HttpServer1.IsActive Then
        
        UpdateForm False
        
        ' Basic server configuration
        HttpServer1.ServerName = Trim(editHostName.Text)
        HttpServer1.ServerAddress = Trim(editLocalAddress.Text)
        HttpServer1.ServerPort = CLng(Trim(editLocalPort.Text))
        HttpServer1.Identity = Trim(editIdentity.Text)
        HttpServer1.Directory = Trim(editDirectory.Text)
        
        ' Server limits
        HttpServer1.MaxClients = CLng(editMaxClients.Text)
        HttpServer1.IdleTime = CLng(editIdleTime.Text)
                   
        ' Server options
        HttpServer1.Secure = CBool(chkSecure.Value)
        HttpServer1.LocalUser = CBool(chkLocalUser.Value)
        HttpServer1.MultiUser = CBool(chkMultiUser.Value)
        HttpServer1.LockFiles = CBool(chkLockFiles.Value)
        HttpServer1.Restricted = CBool(chkRestricted.Value)
        HttpServer1.ReadOnly = CBool(chkReadOnly.Value)
        HttpServer1.HiddenFiles = CBool(chkHidden.Value)
        
        ' Server logging
        HttpServer1.LogFormat = comboFormats.ListIndex
        HttpServer1.LogFile = Trim(editLogFile.Text)
        
        ' Start the server
        nError = HttpServer1.Start()
        If nError > 0 Then
            MsgBox HttpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        cmdStart.Caption = "Stop"
        UpdateStatus "Server accepting connections on " & HttpServer1.ServerAddress & ":" & HttpServer1.ServerPort
        UpdateForm True
    Else
        UpdateForm False
        
        nError = HttpServer1.Stop()
        
        If nError > 0 Then
            MsgBox HttpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        cmdStart.Caption = "Start"
    End If
End Sub

Private Sub cmdSuspend_Click()
    Dim nError As Long
    
    If cmdSuspend.Caption = "Suspend" Then
        UpdateForm False
            
        nError = HttpServer1.Suspend()
        
        If nError > 0 Then
            MsgBox HttpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
            
        cmdSuspend.Caption = "Resume"
        UpdateStatus "Server suspended accepting new client connections"
        UpdateForm True
    Else
        UpdateForm False
            
        nError = HttpServer1.Resume()
            
        If nError > 0 Then
            MsgBox HttpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
            
        cmdSuspend.Caption = "Suspend"
        UpdateStatus "Server resumed accepting new client connections"
        UpdateForm True
    End If
    
End Sub

Private Sub cmdRestart_Click()
    Dim nError As Long
    
    UpdateForm False
    
    nError = HttpServer1.Restart()
    If nError > 0 Then
        MsgBox HttpServer1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    UpdateStatus "The server has been restarted"
    UpdateForm True
End Sub

Private Sub cmdClose_Click()
    Dim nError As Long
    
    If HttpServer1.IsActive Then
        UpdateForm False
        
        nError = HttpServer1.Stop()
        
        If nError > 0 Then
            MsgBox HttpServer1.LastErrorString, vbExclamation
            UpdateForm True
            Exit Sub
        End If
        
        UpdateForm True
    End If

    Unload Me
End Sub

Private Sub HttpServer1_OnAuthenticate(ByVal ClientId As Variant, ByVal HostName As Variant, ByVal UserName As Variant, ByVal Password As Variant)
    Debug.Print "Client " & ClientId & " authenticating as " & UserName
End Sub

Private Sub HttpServer1_OnCommand(ByVal ClientId As Variant, ByVal Command As Variant, ByVal Resource As Variant, ByVal Parameters As Variant)
    Debug.Print "Client " & ClientId & " sent command " & Command & " [" & Parameters & "]"
    Debug.Print "Virtual Path: " & HttpServer1.VirtualPath
    Debug.Print "Local Path:   " & HttpServer1.LocalPath

End Sub

Private Sub HttpServer1_OnConnect(ByVal ClientId As Variant, ByVal ClientAddress As Variant)
    Debug.Print "Client " & ClientId & " connected from " & ClientAddress
    UpdateStatus "Client " & ClientId & " connected from " & ClientAddress
End Sub

Private Sub HttpServer1_OnDisconnect(ByVal ClientId As Variant)
    Debug.Print "Client " & ClientId & " disconnected"
    UpdateStatus "Client " & ClientId & " disconnected from the server"
End Sub

Private Sub HttpServer1_OnDownload(ByVal ClientId As Variant, ByVal FileName As Variant, ByVal FileSize As Variant)
    Debug.Print "Client " & ClientId & " downloaded " & FileName & " (" & FileSize & " bytes)"
End Sub

Private Sub HttpServer1_OnError(ByVal ClientId As Variant, ByVal ErrorCode As Variant, ByVal Description As Variant)
    Debug.Print "Client " & ClientId & " error " & ErrorCode & ": " & Description
End Sub

Private Sub HttpServer1_OnExecute(ByVal ClientId As Variant, ByVal Resource As Variant, ByVal Parameters As Variant, ByVal Output As Variant, ByVal ExitCode As Variant)
    Debug.Print "Client " & ClientId & " executed " & Resource & " (" & ExitCode & ")"
End Sub

Private Sub HttpServer1_OnIdle()
    Debug.Print "All clients have disconnected, the server is idle"
End Sub

Private Sub HttpServer1_OnResult(ByVal ClientId As Variant, ByVal Command As Variant, ByVal Resource As Variant, ByVal ResultCode As Variant)
    Debug.Print "Client " & ClientId & " command " & Command & " completed (" & ResultCode & ")"
End Sub

Private Sub HttpServer1_OnStart()
    Debug.Print "Server has started accepting connections"
    UpdateStatus "Server accepting connections on " & HttpServer1.ServerAddress & ":" & HttpServer1.ServerPort
    UpdateForm True
End Sub

Private Sub HttpServer1_OnStop()
    Debug.Print "Server has stopped, all clients terminated"
    UpdateStatus "Server stopped accepting connections"
    UpdateForm True
End Sub

Private Sub HttpServer1_OnTimeout(ByVal ClientId As Variant, ByVal Elapsed As Variant)
    Debug.Print "Client " & ClientId & " timed out after " & Elapsed & " seconds"
End Sub

Private Sub HttpServer1_OnUpload(ByVal ClientId As Variant, ByVal FileName As Variant, ByVal FileSize As Variant)
    Debug.Print "Client " & ClientId & " uploaded " & FileName & " (" & FileSize & " bytes)"
End Sub

