VERSION 5.00
Begin VB.Form formConnect 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Connection"
   ClientHeight    =   3420
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5040
   ControlBox      =   0   'False
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3420
   ScaleWidth      =   5040
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox editTimeout 
      Height          =   315
      Left            =   2700
      TabIndex        =   5
      Text            =   "20"
      Top             =   600
      Width           =   375
   End
   Begin VB.TextBox editAccount 
      Height          =   315
      Left            =   1140
      TabIndex        =   12
      Top             =   1860
      Width           =   3375
   End
   Begin VB.CheckBox chkPassive 
      Caption         =   "Passive Mode"
      Height          =   255
      Left            =   3240
      TabIndex        =   6
      Top             =   640
      Width           =   1335
   End
   Begin VB.ComboBox comboPort 
      Height          =   315
      Left            =   1140
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   600
      Width           =   675
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2580
      TabIndex        =   16
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   375
      Left            =   1140
      TabIndex        =   15
      Top             =   2880
      Width           =   1215
   End
   Begin VB.ComboBox comboOptions 
      Height          =   315
      Left            =   1140
      Style           =   2  'Dropdown List
      TabIndex        =   14
      Top             =   2280
      Width           =   3375
   End
   Begin VB.TextBox editPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   1140
      PasswordChar    =   "*"
      TabIndex        =   10
      Top             =   1440
      Width           =   3375
   End
   Begin VB.TextBox editUserName 
      Height          =   315
      Left            =   1140
      TabIndex        =   8
      Top             =   1020
      Width           =   3375
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   1140
      TabIndex        =   1
      Top             =   180
      Width           =   3375
   End
   Begin VB.Label lblTimeout 
      Caption         =   "Timeout:"
      Height          =   195
      Left            =   1980
      TabIndex        =   4
      Top             =   660
      Width           =   615
   End
   Begin VB.Label lblAccount 
      Caption         =   "&Account:"
      Height          =   195
      Left            =   120
      TabIndex        =   11
      Top             =   1920
      Width           =   915
   End
   Begin VB.Label lblRemotePort 
      Caption         =   "Port:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   660
      Width           =   555
   End
   Begin VB.Label lblConnection 
      Caption         =   "&Connection:"
      Height          =   195
      Left            =   120
      TabIndex        =   13
      Top             =   2340
      Width           =   915
   End
   Begin VB.Label lblPassword 
      Caption         =   "&Password:"
      Height          =   195
      Left            =   120
      TabIndex        =   9
      Top             =   1500
      Width           =   915
   End
   Begin VB.Label lblUserName 
      Caption         =   "&User Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   1080
      Width           =   915
   End
   Begin VB.Label lblHostName 
      Caption         =   "Host &Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   915
   End
End
Attribute VB_Name = "formConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

Public HostName As String
Public RemotePort As Long
Public UserName As String
Public Password As String
Public Account As String
Public Timeout As Long
Public Options As Long
Public Canceled As Boolean

Private Sub UpdateForm()
    If Len(editHostName.Text) = 0 Or _
       Len(comboPort.Text) = 0 Or _
       Len(editUserName.Text) = 0 Or _
       Len(editPassword.Text) = 0 _
    Then
        cmdConnect.Enabled = False
        cmdCancel.Enabled = True
    Else
        cmdConnect.Enabled = True
        cmdCancel.Enabled = True
    End If

    If editUserName.Text = "anonymous" Then
        editPassword.PasswordChar = ""
    Else
        editPassword.PasswordChar = "*"
    End If
End Sub

Private Sub Form_Load()
    Me.Top = (Screen.Height / 2) - (Me.Height / 2)
    Me.Left = (Screen.Width / 2) - (Me.Width / 2)
    
    ' Initialize the port combobox to specify the standard
    ' and secure port numbers
    comboPort.AddItem ftpPortDefault
    comboPort.AddItem ftpPortSecure
    comboPort.ListIndex = 0
    
    ' Initialize the options combobox to specify the
    ' connection options
    comboOptions.AddItem "Standard"
    comboOptions.ItemData(0) = ftpOptionNone
    comboOptions.AddItem "Secure (Implicit)"
    comboOptions.ItemData(1) = ftpOptionImplicitSSL
    comboOptions.AddItem "Secure (Explicit)"
    comboOptions.ItemData(2) = ftpOptionExplicitSSL
    comboOptions.ListIndex = 0
    
    ' Default to passive mode transfers to avoid potential
    ' problems with firewalls or NAT routers
    chkPassive.Value = vbChecked
    
    UpdateForm
End Sub

Private Sub editHostName_Change()
    UpdateForm
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub comboPort_Change()
    UpdateForm
End Sub

Private Sub comboPort_KeyPress(KeyAscii As Integer)
    If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
        Beep
        KeyAscii = 0
    End If
End Sub

Private Sub editPassword_Change()
    UpdateForm
End Sub

Private Sub editPassword_GotFocus()
    editPassword.SelStart = 0
    editPassword.SelLength = Len(editPassword.Text)
End Sub

Private Sub editUserName_Change()
    UpdateForm
End Sub

Private Sub editUserName_GotFocus()
    editUserName.SelStart = 0
    editUserName.SelLength = Len(editUserName.Text)
End Sub

Private Sub cmdCancel_Click()
    Canceled = True
    Me.Hide
End Sub

Private Sub cmdConnect_Click()
    HostName = Trim(editHostName.Text)
    RemotePort = Val(comboPort.Text)
    UserName = Trim(editUserName.Text)
    Password = Trim(editPassword.Text)
    Account = Trim(editPassword.Text)
    Timeout = Val(editTimeout.Text)
    Options = comboOptions.ItemData(comboOptions.ListIndex)
    Canceled = False
    
    If chkPassive.Value = vbChecked Then
        Options = Options Or ftpOptionPassive
    End If
    
    Me.Hide
End Sub
