VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Math Client Example"
   ClientHeight    =   2880
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5505
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2880
   ScaleWidth      =   5505
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtl.SocketWrench Socket1 
      Left            =   4800
      Top             =   2520
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1410
      Left            =   120
      TabIndex        =   13
      Top             =   1320
      Width           =   3675
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Divide"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4080
      TabIndex        =   11
      Top             =   2040
      Width           =   1260
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Multiply"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4080
      TabIndex        =   10
      Top             =   1560
      Width           =   1260
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Subtract"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4080
      TabIndex        =   9
      Top             =   1080
      Width           =   1260
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Add"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4080
      TabIndex        =   8
      Top             =   600
      Width           =   1260
   End
   Begin VB.TextBox Text4 
      Height          =   315
      Left            =   840
      TabIndex        =   7
      Text            =   "25"
      Top             =   920
      Width           =   2955
   End
   Begin VB.TextBox Text3 
      Height          =   315
      Left            =   840
      TabIndex        =   6
      Text            =   "100"
      Top             =   540
      Width           =   2955
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   375
      Left            =   4080
      TabIndex        =   4
      Top             =   120
      Width           =   1260
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   840
      TabIndex        =   1
      Text            =   "127.0.0.1"
      Top             =   120
      Width           =   1515
   End
   Begin VB.TextBox Text2 
      Height          =   315
      Left            =   3000
      TabIndex        =   0
      Text            =   "7100"
      Top             =   120
      Width           =   720
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Value 2:"
      Height          =   195
      Left            =   120
      TabIndex        =   12
      Top             =   960
      Width           =   585
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Value 1:"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   585
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Address:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   165
      Width           =   615
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   2520
      TabIndex        =   2
      Top             =   165
      Width           =   330
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Function SendCommand(ByVal strCommand As String, ByVal varValue1 As Variant, ByVal varValue2 As Variant) As Boolean
    If Len(strCommand) = 0 Then
        MsgBox "An invalid command was specified", vbExclamation
        SendCommand = False
        Exit Function
    End If
    
    strCommand = UCase(strCommand) + " " + CStr(varValue1) + " " + CStr(varValue2)
    SendCommand = Socket1.WriteLine(strCommand)
End Function

Private Function GetResponse(Optional ByRef varResult As Variant) As Boolean
    Dim strBuffer As String
    Dim strResult As String
    
    If Not Socket1.ReadLine(strBuffer) Then
        GetResponse = False
        Exit Function
    End If
    
    If Left(strBuffer, 2) = "OK" Then
        GetResponse = True
        If Not IsMissing(varResult) Then
            varResult = Right(strBuffer, Len(strBuffer) - 3)
        End If
    ElseIf Left(strBuffer, 3) = "ERR" Then
        GetResponse = False
        If Not IsMissing(varResult) Then
            varResult = Right(strBuffer, Len(strBuffer) - 4)
        End If
    Else
        GetResponse = False
        If Not IsMissing(varResult) Then
            varResult = "Unexpected response from the server"
        End If
    End If
End Function

Private Sub DoCommand(ByVal strCommand As String)
    Dim strValue1 As String
    Dim strValue2 As String
    Dim strResult As String
    
    strValue1 = Trim(Text3.Text)
    strValue2 = Trim(Text4.Text)
    
    If Not SendCommand(strCommand, strValue1, strValue2) Then
        MsgBox "Unable to send command to the server", vbExclamation
        Exit Sub
    End If
    
    If Not GetResponse(strResult) Then
        MsgBox strResult, vbExclamation
        Exit Sub
    End If
       
    Select Case strCommand
    Case "ADD"
        List1.AddItem strValue1 & " + " & strValue2 & " = " & strResult
        List1.ListIndex = List1.ListCount - 1
    Case "SUB"
        List1.AddItem strValue1 & " - " & strValue2 & " = " & strResult
        List1.ListIndex = List1.ListCount - 1
    Case "MUL"
        List1.AddItem strValue1 & " x " & strValue2 & " = " & strResult
        List1.ListIndex = List1.ListCount - 1
    Case "DIV"
        List1.AddItem strValue1 & " / " & strValue2 & " = " & strResult
        List1.ListIndex = List1.ListCount - 1
    End Select
    
End Sub

Private Sub Command1_Click()
    If Not Socket1.IsConnected Then
        Dim strHostName As String
        Dim nHostPort As Long
        Dim nError As Long
        
        strHostName = Trim(Text1.Text)
        If Len(strHostName) = 0 Then
            MsgBox "Please enter the hostname or IP address of the server", vbExclamation
            Text1.SetFocus
            Exit Sub
        End If
        
        nHostPort = Val(Text2.Text)
        If nHostPort < 1 Or nHostPort > 65535 Then
            MsgBox "Please enter a valid port number", vbExclamation
            Text2.SetFocus
            Exit Sub
        End If
        
        nError = Socket1.Connect(strHostName, nHostPort)
        If nError > 0 Then
            MsgBox Socket1.LastErrorString, vbExclamation
            Exit Sub
        End If
    
        If Not GetResponse() Then
            MsgBox "Unable to establish a connection with the server", vbExclamation
            Socket1.Disconnect
            Exit Sub
        End If
    
        List1.Clear
        Command1.Caption = "Disconnect"
        Command2.Enabled = True
        Command3.Enabled = True
        Command4.Enabled = True
        Command5.Enabled = True
    Else
        Socket1.Disconnect
        Command1.Caption = "Connect"
        Command2.Enabled = False
        Command3.Enabled = False
        Command4.Enabled = False
        Command5.Enabled = False
    End If
End Sub

Private Sub Command2_Click()
    DoCommand "ADD"
End Sub

Private Sub Command3_Click()
    DoCommand "SUB"
End Sub

Private Sub Command4_Click()
    DoCommand "MUL"
End Sub

Private Sub Command5_Click()
    DoCommand "DIV"
End Sub

