VERSION 5.00
Object = "{5ED042DA-96A9-4014-8EEF-E0840D215B54}#1.0#0"; "cshtpx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools PostData Example"
   ClientHeight    =   5370
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8625
   Icon            =   "PostData.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5370
   ScaleWidth      =   8625
   StartUpPosition =   2  'CenterScreen
   Begin HttpClientCtl.HttpClient HttpClient1 
      Left            =   6960
      Top             =   780
      _cx             =   741
      _cy             =   741
   End
   Begin VB.TextBox editField3 
      Height          =   315
      Left            =   780
      TabIndex        =   7
      Text            =   "Value3"
      Top             =   1200
      Width           =   5895
   End
   Begin VB.TextBox editField2 
      Height          =   315
      Left            =   780
      TabIndex        =   5
      Text            =   "Value2"
      Top             =   860
      Width           =   5895
   End
   Begin VB.TextBox editField1 
      Height          =   315
      Left            =   780
      TabIndex        =   3
      Text            =   "Value1"
      Top             =   520
      Width           =   5895
   End
   Begin VB.TextBox editAddress 
      Height          =   315
      Left            =   780
      TabIndex        =   1
      Text            =   "http://test.sockettools.com/postdata"
      Top             =   180
      Width           =   5895
   End
   Begin VB.TextBox textOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3555
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   9
      Top             =   1680
      Width           =   8355
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Post"
      Default         =   -1  'True
      Height          =   375
      Left            =   6900
      TabIndex        =   8
      Top             =   180
      Width           =   1215
   End
   Begin VB.Label labelField3 
      Caption         =   "Field 3:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   1260
      Width           =   615
   End
   Begin VB.Label labelField2 
      Caption         =   "Field 2:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   920
      Width           =   615
   End
   Begin VB.Label labelField1 
      Caption         =   "Field 1:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   580
      Width           =   615
   End
   Begin VB.Label labelAddress 
      Caption         =   "Address:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   615
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub cmdAction_Click()
    Dim strFormData As String
    Dim strResult As String
    Dim nLength As Long, nError As Long
    
    '
    ' Set the URL property in the control to the address entered
    ' by the user. The default address in this example specifies
    ' a script that will simply echo back the raw form data that
    ' was submitted to it.
    '
    On Error Resume Next: Err.Clear
    HttpClient1.URL = Trim(editAddress.Text)
    If Err.Number Then
        MsgBox Err.Description, vbExclamation
        Exit Sub
    End If
    On Error GoTo 0
    
    '
    ' Create the strFormData variable based on the data specified
    ' by the user; these values are submitted as form variables to
    ' the script using the POST command
    '
    strFormData = "Value1=" + Trim(editField1.Text)
    
    If Len(editField2.Text) > 0 Then
        If Len(strFormData) > 0 Then strFormData = strFormData + "&"
        strFormData = strFormData + "Value2=" + Trim(editField2.Text)
    End If
    
    If Len(editField3.Text) > 0 Then
        If Len(strFormData) > 0 Then strFormData = strFormData + "&"
        strFormData = strFormData + "Value3=" + Trim(editField3.Text)
    End If
    
    cmdAction.Enabled = False
   
    '
    ' Connect to the HTTP server and check for any errors
    ' that may occur; the Connect method is called without
    ' any arguments because the hostname, port number
    ' and resource have already been set as a result of
    ' setting the URL property
    '
    HttpClient1.Timeout = 20 ' Seconds
    
    nError = HttpClient1.Connect()
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        cmdAction.Enabled = True
        Exit Sub
    End If
   
    '
    ' Post the data to the server, using the resource specified in the URL
    ' and the form data composed from the values input by the user; the
    ' results are returned in the strResult variable, and the httpPostConvert
    ' option ensures the that output text is formatted correctly for Windows
    '
    nError = HttpClient1.PostData(HttpClient1.Resource, strFormData, strResult, httpPostConvert)
    
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        cmdAction.Enabled = True
        Exit Sub
    End If
    
    HttpClient1.Disconnect
    
    textOutput.Text = strResult
    cmdAction.Enabled = True
End Sub

Private Sub labelFile_Click()

End Sub

