VERSION 5.00
Object = "{5ED042DA-96A9-4014-8EEF-E0840D215B54}#1.0#0"; "cshtpx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools PostForm Example"
   ClientHeight    =   5370
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8625
   Icon            =   "PostForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5370
   ScaleWidth      =   8625
   StartUpPosition =   2  'CenterScreen
   Begin HttpClientCtl.HttpClient HttpClient1 
      Left            =   6960
      Top             =   780
      _cx             =   741
      _cy             =   741
   End
   Begin VB.TextBox editFileName 
      Height          =   315
      Left            =   780
      TabIndex        =   7
      Top             =   1260
      Width           =   5895
   End
   Begin VB.TextBox editField2 
      Height          =   315
      Left            =   780
      TabIndex        =   5
      Text            =   "Value2"
      Top             =   900
      Width           =   5895
   End
   Begin VB.TextBox editField1 
      Height          =   315
      Left            =   780
      TabIndex        =   3
      Text            =   "Value1"
      Top             =   540
      Width           =   5895
   End
   Begin VB.TextBox editAddress 
      Height          =   315
      Left            =   780
      TabIndex        =   1
      Text            =   "http://test.sockettools.com/postform"
      Top             =   180
      Width           =   5895
   End
   Begin VB.TextBox textOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3555
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   9
      Top             =   1680
      Width           =   8355
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Post"
      Default         =   -1  'True
      Height          =   375
      Left            =   6900
      TabIndex        =   8
      Top             =   180
      Width           =   1215
   End
   Begin VB.Label labelFile 
      Caption         =   "File:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   615
   End
   Begin VB.Label labelField2 
      Caption         =   "Field 2:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   615
   End
   Begin VB.Label labelField1 
      Caption         =   "Field 1:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   615
   End
   Begin VB.Label labelAddress 
      Caption         =   "Address:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   615
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub cmdAction_Click()
    Dim strFileName As String
    Dim strResult As String
    Dim nLength As Long, nError As Long
    
    '
    ' Set the URL property in the control to the address entered
    ' by the user. The default address in this example specifies
    ' a script that will simply echo back the raw form data that
    ' was submitted to it.
    '
    On Error Resume Next: Err.Clear
    HttpClient1.URL = Trim(editAddress.Text)
    If Err.Number Then
        MsgBox Err.Description, vbExclamation
        Exit Sub
    End If
    On Error GoTo 0
    
    cmdAction.Enabled = False
   
    '
    ' Connect to the HTTP server and check for any errors
    ' that may occur; the Connect method is called without
    ' any arguments because the hostname, port number
    ' and resource have already been set as a result of
    ' setting the URL property
    '
    HttpClient1.Timeout = 20 ' Seconds
    
    nError = HttpClient1.Connect()
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        cmdAction.Enabled = True
        Exit Sub
    End If
        
    ' Note that the scripts which process multipart form data are
    ' application specific, which means that you will need to change
    ' this program in order to provide the correct field names if
    ' you want to use a specific script rather than the generic
    ' testing script that is the default.
    '
    HttpClient1.CreateForm HttpClient1.Resource, httpMethodPost, httpFormMultipart
    HttpClient1.AddField "Field1", editField1.Text
    HttpClient1.AddField "Field2", editField2.Text
    
    '
    ' If a filename has been specified, then add the contents of
    ' the file to the form data
    '
    strFileName = Trim(editFileName.Text)
    If Len(strFileName) > 0 Then
        nError = HttpClient1.AddFile("File1", strFileName)
        If nError > 0 Then
            MsgBox "Unable to add the specified file to this form" & vbCrLf & _
                   HttpClient1.LastErrorString, vbExclamation
        End If
    End If
    
    '
    ' Submit the data to the server; anything sent back by the
    ' server will be returned in the strResult string.
    '
    nError = HttpClient1.SubmitForm(strResult, nLength, httpSubmitConvert)
    
    If nError <> 0 Then
        MsgBox HttpClient1.LastErrorString, vbExclamation
        cmdAction.Enabled = True
        Exit Sub
    End If
    
    HttpClient1.Disconnect
    
    textOutput.Text = strResult
    cmdAction.Enabled = True
End Sub
