VERSION 5.00
Begin VB.Form formConnect 
   Caption         =   "Connect"
   ClientHeight    =   2295
   ClientLeft      =   5880
   ClientTop       =   5565
   ClientWidth     =   5475
   LinkTopic       =   "Form1"
   ScaleHeight     =   2295
   ScaleWidth      =   5475
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox editPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   960
      PasswordChar    =   "*"
      TabIndex        =   7
      Top             =   900
      Width           =   2835
   End
   Begin VB.TextBox editUserName 
      Height          =   315
      Left            =   960
      TabIndex        =   5
      Top             =   540
      Width           =   2835
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   435
      Left            =   2790
      TabIndex        =   9
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   435
      Left            =   1470
      TabIndex        =   8
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox editHostPort 
      Height          =   315
      Left            =   4380
      TabIndex        =   3
      Text            =   "119"
      Top             =   180
      Width           =   495
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Text            =   ""
      Top             =   180
      Width           =   2835
   End
   Begin VB.Label labelInfo 
      Caption         =   "Not all servers require a username and password"
      Height          =   195
      Left            =   960
      TabIndex        =   10
      Top             =   1260
      Width           =   3555
   End
   Begin VB.Label Label2 
      Caption         =   "Pass&word:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   960
      Width           =   795
   End
   Begin VB.Label Label1 
      Caption         =   "&Username:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   795
   End
   Begin VB.Label labelHostPort 
      Caption         =   "&Port:"
      Height          =   195
      Left            =   3960
      TabIndex        =   2
      Top             =   240
      Width           =   375
   End
   Begin VB.Label labelHostName 
      Caption         =   "&Server:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   795
   End
End
Attribute VB_Name = "formConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Public HostName As String
Public HostPort As Long
Public UserName As String
Public Password As String
Public Canceled As Boolean

Private Sub Form_Load()
    Me.Left = (Screen.Width / 2) - (Me.ScaleWidth / 2)
    Me.Top = (Screen.Height / 2) - (Me.ScaleHeight / 2)
End Sub

Private Sub cmdConnect_Click()
    Dim strHostName As String
    Dim strHostPort As String
    Dim strUserName As String
    Dim strPassword As String
    
    strHostName = Trim(editHostName.Text)
    strHostPort = Trim(editHostPort.Text)
    strUserName = Trim(editUserName.Text)
    strPassword = Trim(editPassword.Text)
    
    If Len(strHostName) = 0 Then
        MsgBox "Please enter the name of a news server", vbInformation
        editHostName.SetFocus
        Exit Sub
    End If
    
    If Len(strHostPort) = 0 Then
        MsgBox "Please enter a port number", vbInformation
        editHostPort.SetFocus
        Exit Sub
    End If
   
    If Len(strUserName) = 0 Then
        strPassword = ""
    Else
        If Len(strPassword) = 0 Then
            MsgBox "Please enter a password for this user", vbInformation
            editPassword.SetFocus
            Exit Sub
        End If
    End If
   
    HostName = strHostName
    HostPort = Val(strHostPort)
    Canceled = False
    Me.Hide
End Sub

Private Sub cmdCancel_Click()
    Canceled = True
    Me.Hide
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub editHostPort_GotFocus()
    editHostPort.SelStart = 0
    editHostPort.SelLength = Len(editHostPort.Text)
End Sub

Private Sub editUserName_GotFocus()
    editUserName.SelStart = 0
    editUserName.SelLength = Len(editUserName.Text)
End Sub

Private Sub editPassword_GotFocus()
    editPassword.SelStart = 0
    editPassword.SelLength = Len(editPassword.Text)
End Sub
