VERSION 5.00
Object = "{A409F11A-3548-4C1C-84D9-A2431C4605B6}#1.0#0"; "csdnsx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Domain Name Resolver"
   ClientHeight    =   4350
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5370
   Icon            =   "Resolve.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4350
   ScaleWidth      =   5370
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin DnsClientCtl.DnsClient DnsClient1 
      Left            =   4560
      Top             =   3840
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   2828
      TabIndex        =   8
      Top             =   3840
      Width           =   1155
   End
   Begin VB.CommandButton cmdQuery 
      Caption         =   "Query"
      Default         =   -1  'True
      Height          =   375
      Left            =   1380
      TabIndex        =   7
      Top             =   3840
      Width           =   1155
   End
   Begin VB.Frame Frame2 
      Caption         =   "&Domain Information"
      Height          =   2175
      Left            =   120
      TabIndex        =   0
      Top             =   1500
      Width           =   5115
      Begin VB.ListBox listMailServers 
         Height          =   840
         Left            =   1320
         TabIndex        =   6
         Top             =   1200
         Width           =   3495
      End
      Begin VB.TextBox editHostName 
         Height          =   315
         Left            =   1320
         TabIndex        =   2
         Text            =   "microsoft.com"
         Top             =   360
         Width           =   3495
      End
      Begin VB.TextBox editHostAddress 
         Height          =   315
         Left            =   1320
         TabIndex        =   4
         Top             =   780
         Width           =   3495
      End
      Begin VB.Label Label5 
         Caption         =   "Mail Servers:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   1200
         Width           =   975
      End
      Begin VB.Label Label3 
         Caption         =   "Host &Name:"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   420
         Width           =   915
      End
      Begin VB.Label Label4 
         Caption         =   "Host &Address:"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   840
         Width           =   1035
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Name &Servers"
      Height          =   1275
      Left            =   120
      TabIndex        =   9
      Top             =   120
      Width           =   5055
      Begin VB.TextBox editNameServer2 
         Height          =   315
         Left            =   1320
         TabIndex        =   13
         Top             =   720
         Width           =   3495
      End
      Begin VB.TextBox editNameServer1 
         Height          =   315
         Left            =   1320
         TabIndex        =   11
         Top             =   300
         Width           =   3495
      End
      Begin VB.Label Label2 
         Caption         =   "Name Server &2:"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   780
         Width           =   1155
      End
      Begin VB.Label Label1 
         Caption         =   "Name Server &1:"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   360
         Width           =   1155
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    ' Initialize the text controls with the default nameservers
    ' which are configured for the local system; when the control
    ' is first loaded, it will automatically check the local
    ' system configuration
    
    editNameServer1.Text = DnsClient1.NameServer(0)
    editNameServer2.Text = DnsClient1.NameServer(1)
End Sub

Private Sub editNameServer1_LostFocus()
    ' The user may have changed the nameserver IP address;
    ' update the NameServer property array
    
    DnsClient1.NameServer(0) = editNameServer1.Text
End Sub

Private Sub editNameServer2_LostFocus()
    ' The user may have changed the nameserver IP address;
    ' update the NameServer property array
    
    DnsClient1.NameServer(1) = editNameServer2.Text
End Sub

Private Sub editHostAddress_GotFocus()
    editHostAddress.SelStart = 0
    editHostAddress.SelLength = Len(editHostAddress.Text)
End Sub

Private Sub editHostAddress_KeyPress(KeyAscii As Integer)
    editHostName.Text = ""
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub editHostName_KeyPress(KeyAscii As Integer)
    editHostAddress.Text = ""
End Sub

Private Sub listMailServers_Click()
    editHostName.Text = listMailServers.Text
    editHostAddress.Text = ""
End Sub

Private Sub cmdQuery_Click()
    Dim strHostName As String
    Dim strHostAddress As String
    Dim strMailHost As String
    Dim strDomain() As String
    Dim nIndex As Long
    Dim nError As Long
    
    cmdQuery.Enabled = False
    listMailServers.Clear
    
    strHostName = Trim(editHostName.Text)
    strHostAddress = Trim(editHostAddress.Text)
    
    If Len(strHostName) > 0 Then

        ' The user has entered a host name, so perform a
        ' standard query for an Address record

        nError = DnsClient1.Query(strHostName, dnsRecordAddress, strHostAddress)
        If nError <> 0 Then
            MsgBox DnsClient1.LastErrorString, vbExclamation
            cmdQuery.Enabled = True
            editHostName.SetFocus
            Exit Sub
        End If
        
        ' The query was successful and the IP address was
        ' returned in the strHostAddress variable

        editHostAddress.Text = strHostAddress
    
    ElseIf Len(strHostAddress) > 0 Then

        ' The user has entered an IP address, so perform a
        ' reverse DNS lookup by querying for the PTR record

        nError = DnsClient1.Query(strHostAddress, dnsRecordPTR, strHostName)
        If nError <> 0 Then
            MsgBox DnsClient1.LastErrorString, vbExclamation
            cmdQuery.Enabled = True
            editHostAddress.SetFocus
            Exit Sub
        End If
        
        ' The query was successful and the host name was
        ' returned in the strHostName variable; note that
        ' it is not uncommon for an address to not have a
        ' PTR record
        
        editHostName.Text = strHostName
    Else
        ' The user needs to enter a host name or address
        
        MsgBox "Please enter a host name or IP address", vbInformation
        cmdQuery.Enabled = True
        editHostName.SetFocus
        Exit Sub
    End If
    
    ' Determine if there are any mail exchanges for this
    ' domain
    
    If Len(strHostName) > 0 Then

        ' Create the mail server host name by splitting the
        ' the host name
        
        strMailHost = ""
        strDomain = Split(strHostName, ".")
        
        nIndex = UBound(strDomain)
        If nIndex > 0 Then
            strMailHost = strDomain(nIndex - 1) + "." + strDomain(nIndex)
        End If
        
        ' Set the HostName property to the domain name and
        ' then enumerate the mail exchanges for that domain
        
        DnsClient1.HostName = strMailHost
        For nIndex = 0 To DnsClient1.MailExchanges - 1
            listMailServers.AddItem DnsClient1.MailExchange(nIndex)
        Next
    End If
    
    cmdQuery.Enabled = True
    editHostName.SetFocus
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub
