VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{4F4FB8F6-595D-471F-A063-9232D1C668D7}#1.0#0"; "csicmx10.ocx"
Begin VB.Form Form1 
   Caption         =   "SocketTools TraceRoute Example"
   ClientHeight    =   4185
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7185
   LinkTopic       =   "Form1"
   ScaleHeight     =   4185
   ScaleWidth      =   7185
   StartUpPosition =   2  'CenterScreen
   Begin IcmpClientCtl.IcmpClient IcmpClient1 
      Left            =   5160
      Top             =   600
      _cx             =   741
      _cy             =   741
   End
   Begin MSComctlLib.ImageList imgStatus 
      Left            =   5760
      Top             =   540
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   5
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "TraceRoute.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "TraceRoute.frx":015A
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "TraceRoute.frx":02B4
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "TraceRoute.frx":040E
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "TraceRoute.frx":0568
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   285
      Left            =   0
      TabIndex        =   4
      Top             =   3900
      Width           =   7185
      _ExtentX        =   12674
      _ExtentY        =   503
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   2115
      Left            =   0
      TabIndex        =   3
      Top             =   600
      Width           =   4755
      _ExtentX        =   8387
      _ExtentY        =   3731
      View            =   3
      LabelWrap       =   0   'False
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      SmallIcons      =   "imgStatus"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Trace"
      Default         =   -1  'True
      Height          =   315
      Left            =   4800
      TabIndex        =   2
      Top             =   120
      Width           =   1155
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   780
      TabIndex        =   1
      Text            =   "test.sockettools.com"
      Top             =   120
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "System:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Const iconGreen = 1
Private Const iconBlue = 2
Private Const iconYellow = 3
Private Const iconRed = 4
Private Const iconBlack = 5

Private Sub Form_Load()
    ListView1.ColumnHeaders.Add Text:="Hop", Width:=650
    ListView1.ColumnHeaders.Add Text:="Address", Width:=2500
    ListView1.ColumnHeaders.Add Text:="Average", Width:=850
    ListView1.ColumnHeaders.Add Text:="Maximum", Width:=850
    ListView1.ColumnHeaders.Add Text:="Minimum", Width:=850
    ListView1.View = lvwReport
End Sub

Private Sub Form_Resize()
    ListView1.Width = Form1.ScaleWidth - ListView1.Left
    ListView1.Height = Form1.ScaleHeight - StatusBar1.Height - ListView1.Top
End Sub

Private Sub Text1_GotFocus()
    Text1.SelStart = 0
    Text1.SelLength = Len(Text1.Text)
End Sub

Private Sub Text1_Change()
    Command1.Enabled = CBool(Len(Text1.Text) > 0)
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeySpace Then
        Beep
        KeyAscii = 0
    End If
End Sub

Private Sub Command1_Click()
    Dim nResult As Long
    
    Me.MousePointer = vbHourglass
    Command1.Enabled = False
    ListView1.ListItems.Clear
    
    IcmpClient1.AutoResolve = True
    nResult = IcmpClient1.TraceRoute(Text1.Text)
    
    Beep
    StatusBar1.SimpleText = "Traceroute to " & Text1.Text & " completed"
    Command1.Enabled = True
    Me.MousePointer = vbDefault
End Sub

Private Sub IcmpClient1_OnTrace(ByVal Distance As Variant, ByVal RemoteHost As Variant, ByVal Replies As Variant, ByVal TripAverage As Variant, ByVal TripMaximum As Variant, ByVal TripMinimum As Variant)
    Dim listItem As MSComctlLib.listItem
    Dim nIcon As Integer

    If Replies = 0 Then
        nIcon = iconBlack
    Else
        If TripAverage < 100 Then
            nIcon = iconGreen
        ElseIf TripAverage >= 100 And TripAverage <= 299 Then
            nIcon = iconBlue
        ElseIf TripAverage >= 300 And TripAverage <= 499 Then
            nIcon = iconYellow
        ElseIf TripAverage >= 500 Then
            nIcon = iconRed
        End If
    End If
    
    Set listItem = ListView1.ListItems.Add(Text:=Distance, SmallIcon:=nIcon)
    listItem.SubItems(1) = RemoteHost
    listItem.SubItems(2) = TripAverage
    listItem.SubItems(3) = TripMaximum
    listItem.SubItems(4) = TripMinimum
    ListView1.Refresh
End Sub
