VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{5ED042DA-96A9-4014-8EEF-E0840D215B54}#1.0#0"; "cshtpx10.ocx"
Begin VB.Form formMain 
   Caption         =   "SocketTools ViewPage Example"
   ClientHeight    =   4680
   ClientLeft      =   3555
   ClientTop       =   2835
   ClientWidth     =   7545
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   KeyPreview      =   -1  'True
   LinkTopic       =   "formMain"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4680
   ScaleWidth      =   7545
   StartUpPosition =   2  'CenterScreen
   Begin HttpClientCtl.HttpClient HttpClient1 
      Left            =   4260
      Top             =   540
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Get"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   6600
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox editView 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2115
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   480
      Width           =   3555
   End
   Begin VB.TextBox editAddress 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Top             =   120
      Width           =   5295
   End
   Begin MSComDlg.CommonDialog cmnDialog 
      Left            =   3720
      Top             =   540
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label labelStatus 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4380
      Width           =   7455
   End
   Begin VB.Label labelAddress 
      Caption         =   "&Address:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   795
   End
   Begin VB.Menu menuFile 
      Caption         =   "&File"
      Begin VB.Menu menuSaveAs 
         Caption         =   "Save &As..."
      End
      Begin VB.Menu menuSeperator1 
         Caption         =   "-"
      End
      Begin VB.Menu menuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub UpdateForm(ByVal bEnable As Boolean)
    If bEnable Then
        cmdAction.Enabled = True
        cmdAction.Cancel = False
        cmdAction.Caption = "Get"
        editView.Enabled = True
        menuSaveAs.Enabled = CBool(Len(editView.Text) > 0)
        menuExit.Enabled = True
    Else
        editView.Enabled = False
        menuSaveAs.Enabled = False
        menuExit.Enabled = False
    End If
End Sub

Private Function GetBaseFileName(strResource As String) As String
    Dim nIndex As Long
    Dim nStartPos As Long
    Dim nEndPos As Long
    
    nStartPos = 1
    
    For nIndex = Len(strResource) To 1 Step -1
        Select Case Mid$(strResource, nIndex, 1)
            Case ".", "#", "?"
                If nEndPos = 0 Then nEndPos = nIndex - 1
            Case "/", "\"
                nStartPos = nIndex + 1
                Exit For
        End Select
    Next
    
    If nEndPos = 0 Then
        GetBaseFileName = Mid$(strResource, nStartPos)
    Else
        GetBaseFileName = Mid$(strResource, nStartPos, nEndPos - nStartPos + 1)
    End If
End Function

Private Sub Form_Load()
    UpdateForm True
End Sub

Private Sub Form_Resize()
    If WindowState <> vbMinimized Then
        '
        ' The minimum height and width for the form
        '
        If Width < 3000 Then Width = 3000
        If Height < 2500 Then Height = 2500

        '
        ' Adjust the controls based on the new width and/or
        ' height of the form
        '
        editAddress.Width = ScaleWidth - cmdAction.Width - editAddress.Left - 250
        cmdAction.Left = ScaleWidth - 1000
        editView.Width = ScaleWidth
        editView.Height = ScaleHeight - editView.Top - labelStatus.Height
        labelStatus.Width = ScaleWidth
        labelStatus.Top = ScaleHeight - labelStatus.Height
    End If
End Sub

Private Sub cmdAction_Click()
    Dim strBuffer As String
    Dim cbBuffer As Long
    Dim strContentType As String
    Dim nError As Long
    Static bCanceled As Integer

    If cmdAction.Caption = "Cancel" Then
        bCanceled = True
        cmdAction.Enabled = False
        If HttpClient1.State > httpStatusIdle Then HttpClient1.Cancel
        Exit Sub
    End If

    UpdateForm False
    
    On Error Resume Next: Err.Clear
    HttpClient1.URL = Trim(editAddress.Text)
    
    If Err.Number Then
        MsgBox "Please enter a complete URL", vbExclamation
        editAddress.SetFocus
        Exit Sub
    End If
    
    On Error GoTo 0
    
    cmdAction.Caption = "Cancel"
    labelStatus.Caption = ""
    editView.Text = ""
    
    nError = HttpClient1.Connect()
    
    If nError Then
        labelStatus.Caption = "Error " & nError & ": " & HttpClient1.LastErrorString
        MsgBox HttpClient1.LastErrorString, vbExclamation
        UpdateForm True
        Exit Sub
    End If
    
    labelStatus.Caption = "Requesting " & HttpClient1.Resource & " from server..."

    nError = HttpClient1.GetData(HttpClient1.Resource, _
                                strBuffer, cbBuffer, _
                                httpTransferConvert)
    
    If nError Then
        labelStatus.Caption = "Error " & nError & ": " & HttpClient1.LastErrorString
        MsgBox HttpClient1.LastErrorString, vbExclamation
        HttpClient1.Disconnect
        UpdateForm True
        Exit Sub
    End If
    
    HttpClient1.GetHeader "Content-Type", strContentType
    HttpClient1.Disconnect
    
    labelStatus.Caption = "Downloaded " & cbBuffer & " bytes of " & HttpClient1.Resource

    If InStr(strContentType, "text/") = 0 Then
        MsgBox "The resource is not textual and cannot be displayed", vbInformation
    Else
        editView.Text = strBuffer
    End If
    
    '
    ' Update the form controls
    '
    UpdateForm True

End Sub

Private Sub editAddress_GotFocus()
    editAddress.SelStart = 0
    editAddress.SelLength = Len(editAddress.Text)
End Sub

Private Sub editView_KeyPress(KeyAscii As Integer)
    If KeyAscii <> 3 Then KeyAscii = 0
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If (KeyAscii = 13 And cmdAction.Caption <> "Cancel") Or (KeyAscii = 27 And cmdAction.Caption = "Cancel") Then
        KeyAscii = 0
        cmdAction_Click
    End If
End Sub

Private Sub menuExit_Click()
    Unload Me
End Sub

Private Sub menuSaveAs_Click()
    Dim hFile As Integer
    Dim strFileName As String
    Dim nPos As Long

    strFileName = GetBaseFileName(HttpClient1.Resource)
    If strFileName = "" Then strFileName = "index.htm"

    cmnDialog.CancelError = True
    cmnDialog.DefaultExt = "htm"
    cmnDialog.FileName = strFileName
    cmnDialog.Filter = "Web Page (*.htm;*.html)|*.htm;*.html|Text (*.txt)|*.txt|All Files (*.*)|*.*"
    cmnDialog.FilterIndex = 1
    cmnDialog.Flags = cdlOFNOverwritePrompt + cdlOFNPathMustExist + cdlOFNHideReadOnly
    
    On Error GoTo Canceled
    cmnDialog.Action = 2 ' Save As

    On Error GoTo 0
    strFileName = cmnDialog.FileName

    hFile = FreeFile
    Open strFileName For Binary Access Write As #hFile
    Put #hFile, , editView.Text
    Close #hFile
    Exit Sub

Canceled:
    Exit Sub
End Sub




